      SUBROUTINE SIPC_Attach (cdpoolnam, kpoolhandle)
      IMPLICIT NONE
C****
C               *****************************
C               * TOY ROUTINE  -  LEVEL C *
C               * -------------     ------- *
C               *****************************
C
C**** *SIPC_Attach*  
C
C     Purpose:
C     -------
C     Attach toy model to pool 'cdpoolnam' with handle 'kpoolhandle' 
C       
C
C**   Interface:
C     ---------
C       *CALL*  *SIPC_Attach (cdpoolnam, kpoolhandle, kinfo)* 
C
C     Input:
C     -----
C                cdpoolnam   : Pool name
C                kpoolhandle : Pool handle
C
C     Output:
C     ------
C                kinfo    : error status (integer)
C
C     Workspace:
C     ---------
C     None
C
C     Externals:
C     ---------
C     SVIPC_open
C
C     Reference:
C     ---------
C    
C
C     History:
C     -------
C       Version   Programmer     Date      Description
C       -------   ----------     ----      -----------  
C       2.2       S. Valcke      97/08/25  created
C
C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C* ---------------------------- Argument declarations -------------------
C
      CHARACTER*9 cdpoolnam
      INTEGER kpoolhandle, kinfo

C
C* ---------------------------- Local declarations ----------------------
C
      INTEGER imrc
C
C* ---------------------------- Poema verses ----------------------------
C
C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C*    1. Initializations
C        ---------------
C
      WRITE (*,*) ' '
      WRITE (*,*) 
     $    '           ROUTINE SIPC_Attach '
      WRITE (*,*) 
     $    '           *******************     *******'
      WRITE (*,*) ' '
C
C* Zeroes error codes
C
      imrc = 0
C
C*    2. Attach to pool 
C        --------------
C
      CALL SVIPC_open(kpoolhandle, cdpoolnam, 0, imrc)
C
C* Find error if any
C
      IF (imrc .LT. 0) THEN
          WRITE(*,*) 'Problem in opening the pool', cdpoolnam
          CALL ABORT('STOP in SIPC_Attach')
      ELSE
          WRITE(*,*) 'Pool for field exchange is open:', cdpoolnam
      ENDIF
C
C*    3. End of routine
C        --------------
C
      WRITE (*,*) ' '
      WRITE (*,*) 
     $    '          --------- End of routine SIPC_Attach ---------'
      RETURN
      END
