CCC $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_ORCA/common.coupled.h,v 1.1.1.1.6.3 2002/02/04 13:45:09 maisonna Exp $
CCC---------------------------------------------------------------------
CCC
CCC                         COMMON COUPLED
CCC                       ******************
CCC
CCC
CCC  ATMOSPHERE/ICE/OCEAN COUPLING
CCC  GASTON TEAM (CERFACS, Meteo-France, LMD, LSCE, IPSL, LODYC)
CCC
CCC  Purpose :
CCC  ---------
CCC     Include common file
CC
CC   Modifications :
CC   -------------
CC	original : 98 (M.A. Foujols, M. Imbard)
CCC---------------------------------------------------------------------
C
#if defined key_coupled || defined key_debug
CC
CC Coupled model: data from an atmospheric model:
CC      qc()             : total surf. total heat flux (wm-2)
CC      ec()             : surface water flux (kg m-2s-1)
CC      qsrc()           : solar radiation (w m-2)
C
      REAL qc(jpi,jpj), ec(jpi,jpj), qsrc(jpi,jpj)
C
      COMMON/comflr/ qc, ec, qsrc

C OM -- Rajout pour couplage avec glace de mer
C EM -- sstmoy pour calcul du flux non solaire glace/eau
C EM -- calv pour diagnostic sur la calving
#if defined key_ice_lln
      REAL watm(jpi,jpj),tatm(jpi,jpj),hatm(jpi,jpj),vatm(jpi,jpj),
     $    catm(jpi,jpj), sstmoy(jpi,jpj,3), calv(jpi,jpj)
      COMMON/comflr2/watm,tatm,hatm,vatm,catm,sstmoy,calv
#endif
#endif
CC
CC Common/compid/ : coupling
CC -------------------------
CC      nexco            : exchange frequency for fluxes
CC      npioc            : process-id of ocean PROGRAM
CC      nmodcpl          : coupling mode
CC      nflxc2o          : fluxes field number coupler to ocean
CC      ntauc2o          : stress field number coupler to ocean
CC      nfldo2c          : surface field number ocean to coupler
CC      numlhf           : unit to transfer fluxes
CC      numlws           : unit to transfer stress
CC      numlts           : unit to transfer sst
CC      numlic           : unit to transfer ice cover
C
      INTEGER npioc, nexco, nmodcpl, nflxc2o, ntauc2o, nfldo2c 
      INTEGER numlhf, numlws, numlts, numlic, numcpl 
C
      COMMON/compid/ nexco, npioc, nmodcpl, nflxc2o, ntauc2o, nfldo2c,
     $    numlhf, numlws, numlts, numlic, numcpl
CC
CC      cchan            : type of message passing (pipe or clim)
CC      cplmodnam        : model name
CC      cploasis         : coupler name
CC      cpl_f_readflx    : coupler to ocean file name for flx.coupled
CC      cpl_f_readtau    : coupler to ocean file name for tau.coupled
CC      cpl_readflx      : coupler to ocean field name for flx.coupled
CC      cpl_readtau      : coupler to ocean field name for tau.coupled
CC      cpl_f_writ       : ocean to coupler file name for stpcmo
CC      cpl_writ         : ocean to coupler field name for stpcmo
C
      CHARACTER *4 cchan
      CHARACTER *6 cplmodnam
      CHARACTER *5 cploasis 
      CHARACTER *8 cpl_f_readflx(jpmaxfld), cpl_f_readtau(jpmaxfld),
     $    cpl_f_writ(jpmaxfld)
      CHARACTER *8   cpl_readflx(jpmaxfld),cpl_readtau(jpmaxfld),
     $    cpl_writ(jpmaxfld)
c
      COMMON/comppd/ cchan, cplmodnam, cploasis,
     $    cpl_f_readflx, cpl_f_readtau, cpl_f_writ, cpl_readflx,
     $    cpl_readtau, cpl_writ
CC
C@ -- mpoolinit(r/w) : handles associated to model pools for passing initial info
C@
C@ -- mpoolwrit : handles associated to pools used to pass fields exchanged 
C@               from model to coupler (see libsipc/SIPC_Write_Model.f)
C@
C@ -- mpoolread : handles associated to pools used to pass fields exchanged
C@               from model to coupler (see libsipc/SIPC_Read_Model.f) 
C@ 
C     -------------------------------------------------------------------
C
      INTEGER  mpoolinitr
      INTEGER  mpoolinitw
      INTEGER  mpoolwrit(jpmaxfld)
      INTEGER  mpoolread(jpmaxfld)
      COMMON / compool / mpoolinitr, mpoolinitw, mpoolwrit, mpoolread
#if defined key_coupled || defined key_debug
CC      sstoc()          : work array to average sst
CC      sieoc()          : work array to average Ice INDEX
CC      alboc()          : work array to average Ice Albedo
C
      REAL sstoc(jpi,jpj), sieoc(jpi,jpj)
      REAL alboc(jpi,jpj)
C
      COMMON/comwrk/ sstoc, sieoc, alboc
C
C     -------------------------------------------------------------------
#endif
CC
