CCC $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_ORCA/common.h,v 1.1.1.1.6.3 2002/02/04 13:45:10 maisonna Exp $
CCC---------------------------------------------------------------------
CCC
CCC                         O R C A model
CCC                       ****************
CCC
CCC                            common
CCC
CCC  Purpose :
CCC  ---------
CCC     Include common file
CCC
CC   
CC
CC      comxxx for real variables or real arrays
CC      cimxxx for integer
CC
CC   Modifications :
CC   -------------
CC      original  : 91 (Delecluse, Imbard, Levy, Madec)
CC      additions : 93 (Imbard, Madec) release 7.1
CC                : 95 (Imbard) first release 8.1
CC                : 95 (M.A.Filiberti) ice
CC                : 96 (M. Imbard & G. Madec) release 8.0
CC                : 96 (A. Weaver) correction to preconditioning
CC                : 97 (M. Imbard & G. Madec) release 8.1
CC                : 98 (M. Guyon) FETI method
CC                : 98-01 (G.Madec & M. ioualalen) adding COMSPR for
CC                                                surface pressure
CC                : 98-10 (G. Roullet) free surface
CC                : 99-09 (E. Guilyardi) trends
CC                : 00-03 (G. Madec) no slip accurate
CC                : 00-07 Open Bondary Conditions
CC                  (Jean-Marc Molines, M. Imbard, CLIPPER project)
CC                : 00-08 (G. Madec) double diffusive mixing
CCC---------------------------------------------------------------------
CCC  OPA8.2, LODYC-IPSL (2001)
CCC---------------------------------------------------------------------
CC
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C I. MODEL SET UP
C ===============
C
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC Common/comnam/  : namelist parameters
CC -------------------------------------
CC namrun:  parameters of the run
CC	no     	: job number
CC	cexper 	: experience name for vairmer format
CC	lrstar 	: boolean term for restart (true or false)
CC	nrstdt 	: control of the time step (0, 1 or 2)
CC	nit000 	: number of the first time step
CC	nitend 	: number of the last time step
CC	ndate0 	: initial calendar date aammjj
CC	nbisex 	: Leap year calendar (0/1)
CC	nprint 	: level of print (0 no print)
CC	nstock 	: frequency of restart file
CC	nwrite 	: frequency of OUTPUT file
CC	ncpu   	: number of cpu (for macrotasking run)
CC namdom   space and time domain (bathymetry, mesh, timestep)
CC	ntopo  	: = 0/1 ,compute/read the integer bathymetry file
CC	ngrid  	: = 0/1, compute/read the horizontal mesh file
CC	nmsh   	: = 1 create a mesh-mask file 
CC	nizoom 	: index i for the sub domain left bottom
CC	njzoom 	: index j for the sub domain left bottom
CC	nacc   	: = 0/1 use of the acceleration of convergence method
CC	atfp   	: asselin time filter parameter
CC      rdt    	: time step for the dynamics (and tracer if nacc=0)
CC	rdtmin 	: minimum time step on tracers
CC	rdtmax 	: 	: maximum time step on tracers
CC	rdth   	: 	: depth variation of tracer step
CC      nclosea : = 1 closed sea (Black & Caspian Sea, Great US Lakes..)
CC              : = 0 no closed sea
CC namhdf   horizontal diffusion
CC	ahm0   	: horizontal eddy viscosity for the dynamics (m2/s)
CC	ahmb0  	: background eddy viscosity for isopycnal diff. (m2/s)
CC	aht0   	: horizontal eddy diffusivity for tracers (m2/s)
CC	ahtb0  	: background eddy diffusivity for isopycnal diff. (m2/s)
CC	aeiv0  	: eddy induced velocity coefficient (m2/s)
CC namzdf   vertical diffusion
CC	avm0   	: vertical eddy viscosity for the dynamic (m2/s)
CC	avt0   	: vertical eddy diffusivity for tracers (m2/s)
CC	navmt  	: number of sub-time step (explicit time stepping)
CC	avevd  	: vertical eddy coeff. for enhanced vert. diff. (m2/s)
CC	nnpc1  	: non penetrative convective scheme frequency
CC	nnpc2  	: non penetrative convective scheme print frequency
CC	ntrbbl 	: = 0/1 bottom boundary layer scheme indicator 
CC	atrbbl 	: lateral coeff. for bottom boundary layer scheme (m2/s)
CC namric   richardson number dependent vertical diffusion
CC	avmri  	: maximum value of the vertical viscosity
CC	alp    	: coefficient of the parameterization
CC	nric   	: coefficient of the parameterization
CC namtke   turbulent eddy kinetic dependent vertical diffusion
CC	ediff  	: coeff. for vertical eddy coef.; avt=ediff*mxl*sqrt(e)
CC	ediss  	: coef. of the Kolmogoroff dissipation
CC	ebb    	: coef. of the surface input of tke
CC	efave  	: coef. for the tke vert. diff. coeff.; avtke=efave*avm
CC	emin   	: minimum value of tke (m2/s2)
CC	emin0  	: surface minimum value of tke (m2/s2)
CC	nitke  	: number of restart iterative loops
CC	nmxl   	: = 0/1/2/3 flag for the type of mixing length used
CC	npdl   	: = 0/1/2 flag on prandtl number on vert. eddy coeff.
CC namddm   double diffusive mixing
CC	avts  	: maximum value of avs for salt fingering
CC	hsbfr    	: heat/salt buoyancy flux ratio
CC nammbc   lateral and bottom momentum boundary condition
CC	shlat  	: type of lateral boundary condition on velocity
CC	nbotfr  : = 0/1/2/3 type of bottom friction
CC	bfri1 	: bottom drag coefficient (linear case)
CC	bfri2 	: bottom drag coefficient (non linear case)
CC	bfeb2 	: bottom turbulent kinetic energy  (m^2/s^2)
CC namqsr   penetrative solar radiation
CC	rabs  	: fraction of qsr associated with xsi1
CC	xsi1  	: first depth of extinction
CC	xsi2  	: second depth of extinction
CC namtdp   tracer newtonian damping
CC      ndmp    : = 0/-1/'latitude' for damping over T and S
CC      ndmpf   : = 1 create a damping.coeff NetCDF file
CC      nmldmp  : = 1/2 flag for damping in the mixed layer
CC      sdmp    : surface time scale for internal damping (days)
CC      bdmp    : bottom time scale for internal damping (days)
CC      hdmp    : depth of transition between sdmp and bdmp (meters)
CC nameos   ocean physical parameters
CC	neos  	: = 0/1/2 type of eq. of state and Brunt-Vaisala frequ.
CC	rau0  	: volumic mass of reference
CC	ralpha	: thermal expension coeff. (linear equation of state)
CC	beta 	: saline  expension coeff. (linear equation of state)
CC	rcp   	: ocean specific heat
CC namsol   elliptic solver / island / free surface
CC	nsolv	: = 1/2/3 type of elliptic solver
CC	nmax 	: maximum of iterations for the solver
CC	eps  	: absolute precision of the solver
CC	sor  	: optimal coefficient for sor solver
CC	epsisl	:absolute precision on stream function solver
CC	nmisl	: maximum pcg iterations for island
CC	rnu  	: strength of the additional force used in free surface
CC namdia    diagnostics on dynamics and/or tracer trends
CC	ntrd  	: time step frequency dynamics and tracers trends
CC	nctls  	: control surface type for trends vertical integration
CC namspr  surface pressure diagnostic
CC	nmaxp 	: maximum of iterations for the solver
CC	epsp  	: absolute precision of the solver
CC	niterp	: number of iteration done by the solver
CC namcpl  coupled ocean/atmosphere model 
CC	nexco 	: coupling frequency in time steps
CC	cchan 	: coupling technique 'PIPE' or 'CLIM'
CC	nmodcpl	: 
CC	cplmodnam : 
CC	cploasis: 
CC	nfldo2c :     
CC	nflxc2o : 
CC	ntauc2o : 
CC	cpl_writ(), cpl_f_writ(), cpl_readflx(), cpl_f_readflx()
CC	cpl_readtau(), cpl_f_readtau()
C
      CHARACTER (len=16) cexper      
      CHARACTER (len=48) crestart
C
      LOGICAL lrstar
C
      INTEGER no, nrstdt, nit000, nitend, ndate0, nbisex, nstock,
     $        nprint, nwrite , ncpu,
     $        ntopo, ngrid, nmsh, nizoom, njzoom, nacc, nclosea,
     $        navmt, nnpc1, nnpc2, ntrbbl,
     $        nric,
     $        nitke, nmxl, npdl,
     $        nbotfr,
     $        ndmp, ndmpf, nmldmp,
     $        neos,
     $        nsolv, nmax, nmisl,
     $        ntrd, nctls,
     $        nmaxp, niterp
C
      REAL atfp, rdt, rdtmin, rdtmax, rdth, 
     $     ahm0, ahmb0, aht0, ahtb0, aeiv0,
     $     avm0, avt0, avevd, atrbbl,
     $     avmri, alp, 
     $     ediff, ediss, ebb, efave, emin, emin0,
     $     avts, hsbfr,
     $     shlat, bfri1, bfri2, bfeb2,
     $     rabs, xsi1, xsi2,
     $     sdmp, bdmp, hdmp,
     $     rau0, ralpha, rbeta, rcp,
     $     eps, sor, epsisl, rnu,
     $     epsp
CC
      COMMON/clmnam/ cexper, crestart, lrstar
      COMMON/cimnam/ no, nrstdt, nit000, nitend, ndate0, nbisex, nstock,
     $        nprint, nwrite , ncpu,
     $        ntopo, ngrid, nmsh, nizoom, njzoom, nacc, nclosea,
     $        navmt, nnpc1, nnpc2, ntrbbl,
     $        nric,
     $        nitke, nmxl, npdl,
     $        nbotfr,
     $        ndmp, ndmpf, nmldmp,
     $        neos,
     $        nsolv, nmax, nmisl,
     $        ntrd, nctls,
     $        nmaxp, niterp
C
      COMMON/comnam/atfp, rdt, rdtmin, rdtmax, rdth,
     $     ahm0, ahmb0, aht0, ahtb0, aeiv0,
     $     avm0, avt0, avevd, atrbbl,
     $     avmri, alp,
     $     ediff, ediss, ebb, efave, emin, emin0,
     $     avts, hsbfr,
     $     shlat, bfri1, bfri2, bfeb2,
     $     rabs, xsi1, xsi2,
     $     sdmp, bdmp, hdmp,
     $     rau0, ralpha, rbeta, rcp,
     $     eps, sor, epsisl, rnu,
     $     epsp
CC
CC----------------------------------------------------------------------
CC Common/comdom/  : domain parameters
CC -----------------------------------
CC      nperio           : lateral boundary condition type 
CC      nimpp,njmpp      : (i,j) indexes for mpp-subdomain left bottom
CC      nreci,nrecj      : overlap region in i and j
CC      nproc            : number for local processor
CC      narea            : number for local area
CC      nbondi, nbondj   : mark of i- and j-direction local boundaries
CC      npolj            : north fold mark (0, 3 or 4)
CC      nlci, nlcj       : i, j dimensions of the local subdomain
CC      nldi, nlei,      : first and last indoor i- and j-indexes
CC      nldj, nlej   
CC      noea, nowe,      : index of the local neighboring processors in
CC      noso, nono         east, west, south and north directions
CC      npne, npnw       : index of north east and north west processor
CC      npse, npsw       : index of south east and south west processor
CC      nbne, nbnw       : logical of north east & north west processor
CC      nbse, nbsw       : logical of south east & south west processor
CC      nimppt(),njmppt(): i-, j-indexes for each processor
CC      nlcit(), nlcjt() : dimensions of every subdomain
CC      nldit(), nldjt() : first, last indoor index for each i-domain
CC      nleit(), nlejt() : first, last indoor index for each j-domain
CC      mindi(), mindj() : indexes array of the subdomain
CC
      INTEGER nimpp, njmpp, nperio, narea, nlci, nlcj
      INTEGER nbondi, nbondj, npolj, nproc, noea, nowe, noso, nono
      INTEGER npne, npnw, npse, npsw, nbne, nbnw, nbse, nbsw
      INTEGER nreci, nrecj, nldi, nlei, nldj, nlej, nizarc, njzarc
      INTEGER mindi(jpi), mindj(jpj)
      INTEGER nimppt(jpnij), njmppt(jpnij), nlcit(jpnij), nlcjt(jpnij)
      INTEGER  nldit(jpnij),  nldjt(jpnij), nleit(jpnij), nlejt(jpnij)
C
      COMMON/cimdom/ nimpp, njmpp, nperio, narea,
     $    nlci, nlcj, nbondi, nbondj, npolj, nproc, noea, nowe, noso,
     $    nono,npne, npnw, npse, npsw, nbne, nbnw, nbse, nbsw,nizarc,
     $    njzarc, nreci, nrecj, nldi, nlei, nldj, nlej,mindi, mindj,
     $    nlcit, nlcjt, nimppt, njmppt, nldit, nldjt,nleit, nlejt
CC
CC----------------------------------------------------------------------
CC Common/cimnum/ : logical units
CC ------------------------------
CC      numstp   : logical unit for time step
CC      numcoo   : logical unit of coordinate file
CC      nummsh   : logical unit of coordinate/meshes output file
CC      numhba   : logical unit for bathymetry file (meters)
CC      numbat   : logical unit for bathymetry file
CC      numsol   : logical unit for solver statistics
CC      numisl   : logical unit for bsf of island input
CC      numisp   : logical unit for island statistics
CC      numtau   : logical unit for surface wind data
CC      numsst   : logical unit for surface temperature data
CC      numtrd   : logical unit for trends diagnostic
CC
      INTEGER numstp, numcoo, nummsh, numhba, numbat, numsol,
     $        numisl, numisp, numtau, numtav, numsst, numtrd
C
      COMMON/cimnum/ numstp, numcoo, nummsh, numhba, numbat, numsol,
     $               numisl, numisp, numtau, numtav, numsst, numtrd
CC
CC----------------------------------------------------------------------
CC Common/comcst/ : physical constants
CC -----------------------------------
CC      nbiss()          : number of days per month (leap-year)
CC      nobis()          : number of days per month (365 days a year)
CC      rpi              : pi
CC      rday             : day
CC      rsiyea           : sideral year
CC      rsiday           : sideral day  
CC      omega            : earth rotation parameter
CC      ra               : earth radius (meter)
CC      g                : gravity
CC      rtt              : fusion point
CC      rt0              : zero celsius
CC      rauw             : density of pure water kg/m3
CC      ro0cpr           : = 1. / ( rau0 * rcp )
CC      rad              : conversion coeff. from degre into radian
CC      rcs              : conversion coeff. from millimeter per day
CC                         into meter per second
CC      raajj            : number of days in one year
CC      raamo            : number of months in one year
CC      rjjhh            : number of hours in one day
CC      rhhmm            : number of minutes in one hour
CC      rmmss            : number of seconds in one minute
CC      raass            : number of seconds in one year
CC      rmoss            : number of seconds in one month
CC      rjjss            : number of seconds in one day
CC      rsmall            : smallest real computer value
C
      INTEGER nbiss(12), nobis(12)
C
      REAL rpi, rday, rsiyea, rsiday, omega, ra, g, rtt, rt0,
     $     rauw, ro0cpr, rad, rcs, raajj, raamo, rjjhh, rhhmm, rmmss,
     $     raass, rmoss, rjjss, rsmall
CC
      COMMON/cimcst/ nbiss, nobis
C
      COMMON/comcst/ rpi, rday, rsiyea, rsiday, omega, ra, g, rtt, rt0,
     $     rauw, ro0cpr, rad, rcs, raajj, raamo, rjjhh, rhhmm, rmmss,
     $     raass, rmoss, rjjss, rsmall
CC
CC----------------------------------------------------------------------
CC Common/comstp/ : time step
CC --------------------------
CC      atfp1            : asselin time filter coeff. (atfp1= 1-2*atfp)
CC      rdttra()         : vertical profile of tracer time step
CC
      REAL atfp1
      REAL rdttra(jpk)
CC
      COMMON/comstp/ atfp1,
     $               rdttra
CC
CC----------------------------------------------------------------------
CC Common/comcoh/  : horizontal curvilinear coordinate and scale factors
CC ---------------------------------------------------------------------
CC      njpi, njpj       : read dimensions
CC      rra              : read earth radius
CC      glamt()          : longitude of t-point (degre)
CC      glamu()          : longitude of u-point (degre)
CC      glamv()          : longitude of v-point (degre)
CC      glamf()          : longitude of f-point (degre)
CC      gphit()          : latitude  of t-point (degre)
CC      gphiu()          : latitude  of u-point (degre)
CC      gphiv()          : latitude  of v-point (degre)
CC      gphif()          : latitude  of f-point (degre)
CC      e1t,e2t()        : horizontal scale factors at t-point (m)
CC      e1u,e2u()        : horizontal scale factors at u-point (m)
CC      e1v,e2v()        : horizontal scale factors at v-point (m)
CC      e1f,e2f()        : horizontal scale factors at f-point (m)
CC	ff()             : coriolis factor (2.*omega*sin(yphi) ) (s-1)
CC      gsinu()          : matrix element for change grid u (repcmo.F)
CC      gcosu()          : matrix element for change grid u (repcmo.F)
CC      gsinv()          : matrix element for change grid v (repcmo.F)
CC      gcosv()          : matrix element for change grid v (repcmo.F)
CC      gsinus()         : matrix element for change grid (repere.F)
CC      gcosin()         : matrix element for change grid (repere.F)
C
      INTEGER njpi, njpj
C
      COMMON/cimcoh/ njpi, njpj
C
      REAL rra
      REAL glamt(jpi,jpj), glamu(jpi,jpj), glamv(jpi,jpj),glamf(jpi,jpj)
      REAL gphit(jpi,jpj), gphiu(jpi,jpj), gphiv(jpi,jpj),gphif(jpi,jpj)
      REAL e1t(jpi,jpj), e1u(jpi,jpj), e1v(jpi,jpj), e1f(jpi,jpj)
      REAL e2t(jpi,jpj), e2u(jpi,jpj), e2v(jpi,jpj), e2f(jpi,jpj)
      REAL ff(jpi,jpj)
      REAL gsinu(jpi,jpj), gcosu(jpi,jpj), gsinv(jpi,jpj),gcosv(jpi,jpj)
      REAL gsinus(jpi,jpj), gcosin(jpi,jpj)
C
      COMMON/comcoh/ rra,
     $       glamt, glamu, glamv, glamf, gphit, gphiu, gphiv, gphif,
     $       e1t, e1u, e1v, e1f, e2t, e2u, e2v, e2f, ff,
     $       gsinu, gcosu, gsinv, gcosv, gsinus, gcosin
CC
CC----------------------------------------------------------------------
CC Common/comcoz/  : vertical coordinate and scale factors
CC -------------------------------------------------------
#if defined key_s_coord
CC                   s-coordinate ('key_s_coord')
CC                   ----------------------------
CC      hbatt(), hbatu() : ocean depth at the vertical of  t-, u-, v-
CC      hbatv(), hbatf()   and f-point (m)
CC      gsigt(), gsigw() : model level depth coefficient at t-, w-levels
CC      gsi3w()          : model level depth coefficient at w-level
CC                         defined as the sum of e3w scale factors
CC      esigt(), esigw() : vertical scale factor coef. at t-, w-levels
C
      REAL hbatt(jpi,jpj), hbatu(jpi,jpj), hbatv(jpi,jpj),hbatf(jpi,jpj)
      REAL gsigt(jpk), gsigw(jpk), gsi3w(jpk), esigt(jpk), esigw(jpk)
C
      COMMON/comcoz/ hbatt, hbatu, hbatv, hbatf,
     $       gsigt, gsigw, gsi3w, esigt, esigw
CC
#  else
CC                  z-coordinate (default option)
CC                  ------------------------------
CC      gdept(), gdepw() : depth of t- and w-points (m)
CC      e3t(), e3w()     : vertical scale factors at t- and w-points (m)
CC
      REAL gdept(jpk), gdepw(jpk), e3t(jpk), e3w(jpk)
C
      COMMON/comcoz/ gdept, gdepw, e3t, e3w
#endif
CC
CC----------------------------------------------------------------------
CC Common/comask/  : masks, bathymetry
CC -----------------------------------
CC      mbathy()         : number of ocean level (=0, 1, ... , jpk-1)
CC      tmask(), umask() : land/ocean mask at t-, u-, v- and f-points
CC      vmask(), fmask()
CC      bmask()          : land/ocean mask of barotropic stream function
CC      tpol(), upol()   : north fold mask (nperio= 3 or 4)
CC      vpol(), fpol()
CC
      INTEGER mbathy(jpi,jpj)
C
      COMMON/cimask/ mbathy
C
      REAL tmask(jpi,jpj,jpk), fmask(jpi,jpj,jpk)
      REAL umask(jpi,jpj,jpk), vmask(jpi,jpj,jpk), bmask(jpi,jpj)
      REAL tpol(jpiglo), upol(jpiglo), vpol(jpiglo), fpol(jpiglo)
C
      COMMON/comask/ tmask, fmask, umask, vmask, bmask,
     $     tpol, upol, vpol, fpol
CC
#ifdef key_noslip_accurate
C
      INTEGER npcoa(4,jpk),nicoa(2*(jpi+jpj),4,jpk)
      INTEGER njcoa(2*(jpi+jpj),4,jpk)
C
      COMMON/cistraight/npcoa,nicoa,njcoa
C
#endif
CC
CC----------------------------------------------------------------------
CC Common/comsea/  : closed sea
CC ----------------------------
CC      ncsi1(), ncsj1(), ncsi2(), ncsj2() : Closed sea limits
CC      ncsir(), ncsjr()                   : Location of run-off
CC      ncstt()                            : Type of closed sea
CC
      INTEGER ncsi1(jpncs), ncsj1(jpncs), ncsi2(jpncs), ncsj2(jpncs),
     $        ncsir(jpncs), ncsjr(jpncs), ncstt(jpncs)
C
      COMMON/cimask/ ncsi1, ncsj1, ncsi2, ncsj2, ncsir, ncsjr, ncstt
C
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC II. DYNAMICS AND TRACERS
CC ========================
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC Common/combef/  : previous fields (before)
CC -----------------------------------------
CC	ub(), vb()       : horizontal velocity (m s-1)
CC	tb(), sb()       : pot. temperature (celsius), salinity (psu)
CC	rotb(), hdivb()  : relative vorticity, horizontal divergence
C
      REAL ub  (jpi,jpj,jpk), vb  (jpi,jpj,jpk)
      REAL tb  (jpi,jpj,jpk), sb  (jpi,jpj,jpk)
      REAL rotb(jpi,jpj,jpk), hdivb(jpi,jpj,jpk)
C
      COMMON/combef/ ub, vb, tb, sb, rotb, hdivb
CC
CC----------------------------------------------------------------------
CC Common/comnow/  : present fields (now)
CC -------------------------------------
CC	un(), vn(), wn() : horizontal and vertical velocity (m s-1)
CC	rotn(), hdivn()  : relative vorticity, horizontal divergence
CC	tn(),   sn()     : pot. temperature (celsius), salinity (psu)
CC	rdn()            : in situ density anomalie rdn=(rho-rau0)/rau0
CC			   (no units)
CC	rhopn()          : potential volumic mass (kg m-3)
CC      bn2n()           : brunt-vaisala frequency (s-2)
C
      REAL un(jpi,jpj,jpk), vn(jpi,jpj,jpk), wn(jpi,jpj,jpk)
      REAL rotn(jpi,jpj,jpk), hdivn(jpi,jpj,jpk)
      REAL tn(jpi,jpj,jpk), sn(jpi,jpj,jpk)
      REAL rdn(jpi,jpj,jpk), rhopn(jpi,jpj,jpk), bn2n(jpi,jpj,jpk)
C
      COMMON/comnow/ un, vn, wn, rotn, hdivn, tn, sn, rdn, rhopn, bn2n
CC
CC----------------------------------------------------------------------
CC Common/comaft/  : next fields (after)
CC ------------------------------------
CC	ua(), va()       : horizontal velocity (m s-1)
CC	ta(), sa()       : pot. temperature (celsius), salinity (psu)
C
      REAL ua(jpi,jpj,jpk), va(jpi,jpj,jpk)
      REAL ta(jpi,jpj,jpk), sa(jpi,jpj,jpk)
C
      COMMON/comaft/ ua, va, ta, sa
CC
CC----------------------------------------------------------------------
CC Common/comspg/  : surface pressure gradient
CC -------------------------------------------
CC      spgu(), spgv()   : horizontal surface pressure gradient
C
      REAL spgu(jpi,jpj), spgv(jpi,jpj)
C
      COMMON/comspg/ spgu, spgv
CC
#if defined key_freesurf_cstvol
CC----------------------------------------------------------------------
CC Common/comfsc/  : free surface - constant volume formulation
CC ------------------------------------------------------------
CC      etab(), etan()   : before, now sea surface height (meters)
CC      hu()             : depth at u-point
CC      hv()             : depth at v-point
CC      htr()            : depth at t-point
C
      REAL etab(jpi,jpj), etan(jpi,jpj)
      REAL hu(jpi,jpj), hv(jpi,jpj)
C
      COMMON/comfsc/ etab, etan, hu, hv
#  else
CC----------------------------------------------------------------------
CC Common/combsf/  : rigid-lid formulation
CC ---------------------------------------
CC      hur(), hvr()     : inverse of u and v-points ocean depth (m-1)
CC      bsfb(), bsfn()   : before,now barotropic streamfunction (m3 s-1)
CC      bsfd()           : now trend of barotropic streamfunction
C
      REAL hur(jpi,jpj), hvr(jpi,jpj)
      REAL bsfb(jpi,jpj), bsfn(jpi,jpj), bsfd(jpi,jpj)
C
      COMMON/combsf/ hur, hvr, bsfb, bsfn, bsfd

#endif
CC
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC II.bis ELLIPTIC SOLVERS
CC =======================
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC Common/comsol/  : elliptic solver: SOR, PCG or FETI
CC ---------------------------------------------------
CC      numsol           : logical unit for solver statistics
CC      nsolv            : flag for solver type               (namelist)
CC      nmax             : solver maximum number of iteration (namelist)
CC      ncut             : indicator of solver convergence
CC      niter            : number of iteration done by the solver
CC      epsilo           : precision for the FETI solver
CC      rnorme, res      : intermediate modulus, solver residu
CC      alph             : coefficient  =(gcr,gcr)/(gcx,gccd)
CC      beta             : coefficient  =(rn+1,rn+1)/(rn,rn)
CC      radd             : coefficient  =(gccd,gcdes)
CC      rr               : coefficient  =(rn,rn)
CC      gcx(), gcxb()    : now, before solution of the elliptic equation
CC      gcp()            : barotropic matrix extra-diagonal elements
CC      gcdprc()         : inverse diagonal preconditioning matrix
CC      gcdmat()         : diagonal preconditioning matrix
CC      gcb()            : second member of the barotropic linear system
CC      gcr()            : residu =b-a.x
CC      gcdes()          : vector descente
CC      gccd()           : vector such that ca.gccd=a.d (ca-1=gcdprc)
C
      INTEGER ncut, niter
      COMMON/cimsol/ ncut, niter
C
      REAL epsr, epsilo, rnorme, res, alph, beta, radd, rr
      REAL gcp(jpi,jpj,4), gcdprc(jpi,jpj), gcdmat(jpi,jpj)
      REAL gcx(jpi,jpj),   gcxb (jpi,jpj),  gcb (jpi,jpj)
      REAL gcr(jpi,jpj),   gcdes(jpi,jpj),  gccd(jpi,jpj)
C
      COMMON/comsol/ epsr, epsilo, rnorme, res, alph, beta, radd, rr,
     $       gcp, gcdprc, gcdmat, gcx, gcxb, gcb, gcr, gcdes, gccd
C
#if defined key_feti
CC----------------------------------------------------------------------
CC Common/comfet/  : FETI solver
CC -----------------------------
CC      noeuds           : total number of nodes for a subdomnain
CC      ninterf          : neighbour subdomain number
CC      nni              : interface point number
CC      ndvois()         : neighbour subdomain list
CC      maplistin()      : node pointer at each interface
CC      malistin()       : concatened list of interface nodes
C
      INTEGER nim,nxm,
     $    malxm,malim,malxmax,malimax,
     $    nifmat,njfmat,nelem,npe,matopo,
     $    noeuds,nmorse,maan,
     $    ninterf,ninterfc,nni,nnic,nnih,nnitot,ndir,
     $    mandvois,mandvoisc,
     $    maplistin,maplistih,malistin,
     $    malisdir,npblo,mablo,ndlblo,ndkerep,
     $    malisblo,mansp,ndimax,
     $    miax,may,maz,mapoids,
     $    nmaxd,mj0,nitmax,ntest,
     $    mabitw,mautilu,malambda,mag,mamg,mapg,mawj,madwj,madwwj,
     $    magh,maw,madw,
     $    mautil,mav,madia,mabufin,mabufout,mawork,maae,magamm,
     $    maxnul,maynul,numit0ete,nitmaxete,maeteg,maeteag,
     $    maeted,maetead,maeteadd,maetegamm,maetev,maetew,
     $    madwork
C
      INTEGER mfet(jpi*jpj+2*jpi+2*jpj+51)
C
      COMMON/cimfeti/nim,nxm,
     $    malxm,malim,malxmax,malimax,
     $    nifmat,njfmat,nelem,npe,matopo,
     $    noeuds,nmorse,maan,
     $    ninterf,ninterfc,nni,nnic,nnih,nnitot,ndir,
     $    mandvois,mandvoisc,
     $    maplistin,maplistih,malistin,
     $    malisdir,npblo,mablo,ndlblo,ndkerep,
     $    malisblo,mansp,ndimax,
     $    miax,may,maz,mapoids,
     $    nmaxd,mj0,nitmax,ntest,
     $    mabitw,mautilu,malambda,mag,mamg,mapg,mawj,madwj,madwwj,
     $    magh,maw,madw,
     $    mautil,mav,madia,mabufin,mabufout,mawork,maae,magamm,
     $    maxnul,maynul,numit0ete,nitmaxete,maeteg,maeteag,
     $    maeted,maetead,maeteadd,maetegamm,maetev,maetew,
     $    madwork,mfet
C
      REAL wfeti(jpj*jpi*jpi+13*jpi*jpj+19*(jpi+jpj)
     $    +4*jpnij+33
     $    +2*(jpi+jpj)*(jpnij-jpni)*jpi
     $    +2*(jpi+jpj)*(jpnij-jpnj+jperio)*jpj
     $    +3*(jpnij-jpni)*jpi
     $    +3*(jpnij-jpnj+jperio)*jpj)
C
      REAL res2,rcompt
CC
      COMMON/comfet/wfeti,res2,rcompt
#endif
CC
#if defined key_islands || defined key_debug
CC----------------------------------------------------------------------
CC Common/comisl/ : island contribution
CC ------------------------------------
CC      nimlu,njmlu,nkmlu: i-, j-, k-dimension read 
CC      nlmlu            : time read dimension
CC      nmmlu            : field read dimension
CC      nnmlu            : read islands number
CC      replu            : read absolute precision
CC	miisl(), mjisl() : position of island grid-points
CC	mnisl()	         : number of grid-points for each island
CC	bsfisl()         : barotropic stream function of island
CC	aisl(), aislm1() : island matrix and its inverse
CC	acisl1(),acisl2(): coef. to compute circulations round islands
CC	bisl()           : second member of island linear system
CC	visl()           : trend of island stream function
C
      INTEGER nimlu, njmlu, nnmlu, nkmlu, nlmlu, nmmlu
      INTEGER miisl(jpnisl,0:4,jpisl), mjisl(jpnisl,0:4,jpisl)
      INTEGER mnisl(0:4,jpisl)
C
      COMMON/cimisl/ nimlu, njmlu, nnmlu, nkmlu,
     $       nlmlu, nmmlu, miisl, mjisl, mnisl
C
      REAL replu
      REAL bsfisl(jpi,jpj,jpisl), aisl(jpisl,jpisl), aislm1(jpisl,jpisl)
      REAL acisl1(jpi,jpj,2,jpisl), acisl2(jpi,jpj,2,jpisl)
      REAL bisl(jpisl), visl(jpisl)
C
      COMMON/comisl/ replu,
     $       bsfisl, aisl, aislm1, acisl1, acisl2, bisl, visl 
#    else
CC      no island
#endif
CC
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC III. OCEAN PHYSICS
CC ==================
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC Common/comhdd/ : lateral viscosity (dynamics)
CC ----------------------------------
CC      ahm1(), ahm2()   : lateral diffusivity coef. at t-, f-points
CC	ahm3(), ahm4()	   (harmonic operator) or at u-, v-points (bi-
CC			   harmonic operator). 3D, or 2D or 1D or cons-
CC			   tant coef. depending on 'key_dynhdfcoef.d'
C
#if defined key_dynhdfcoef3d
      REAL ahm1(jpi,jpj,jpk), ahm2(jpi,jpj,jpk)
#  if (defined key_dynhdfiso || defined key_dynhdfgeop) && ! defined key_dynhdfbilap
      REAL ahm3(jpi,jpj,jpk), ahm4(jpi,jpj,jpk)
#   else
      REAL ahm3, ahm4
#  endif
# elif defined key_dynhdfcoef2d
      REAL ahm1(jpi,jpj), ahm2(jpi,jpj)
#  if (defined key_dynhdfiso || defined key_dynhdfgeop) && ! defined key_dynhdfbilap
      REAL ahm3(jpi,jpj), ahm4(jpi,jpj)
#   else   
      REAL ahm3, ahm4
#  endif
# elif defined key_dynhdfcoef1d
      REAL ahm1(jpk), ahm2(jpk)
      REAL ahm3, ahm4
# else
      REAL ahm1, ahm2, ahm3, ahm4
#endif
C
      COMMON/comhdd/ ahm1, ahm2, ahm3, ahm4
CC
CC----------------------------------------------------------------------
CC Common/comhdt/ : lateral diffusivity (tracers)
CC ------------------------------------
CC      aht0             : lateral diffusivity coefficient    (namelist)
CC      ahtb0            : background diffusivity coefficient (m2/s)
CC	ahtu(), ahtv()   : lateral diffusivity coef. at u-, v-, w- t-pts
CC      ahtw(), ahtt()     (harmonic operator: no rotation, use of u-
CC			    and v-points; rotation, use of u-, v- w-pts)
CC			   (biharmonic operator: rotation or not, use of
CC			    t-point only)
CC			   (the arrays used are 3D, 2D, 1D or 0D depen-
CC			    ding on 'key_trahdfcoef.d' )
C
#if defined key_trahdfbilap
      REAL ahtu, ahtv, ahtw
#  if defined key_dynhdfcoef3d
      REAL ahtt(jpi,jpj,jpk)
#   elif defined key_dynhdfcoef2d
      REAL ahtt(jpi,jpj)
#   elif defined key_dynhdfcoef1d
      REAL ahtt(jpk)
#   else
      REAL ahtt
#  endif
# else
#  if defined key_trahdfcoef3d
      REAL ahtu(jpi,jpj,jpk), ahtv(jpi,jpj,jpk), ahtw(jpi,jpj,jpk)
#   elif defined key_trahdfcoef2d
      REAL ahtu(jpi,jpj), ahtv(jpi,jpj), ahtw(jpi,jpj)
#   elif defined key_trahdfcoef1d
      REAL ahtu(jpk), ahtv(jpk), ahtw(jpk)
#   else
      REAL ahtu, ahtv, ahtw
#  endif
      REAL ahtt
#endif
      COMMON/comhdt/ ahtu, ahtv, ahtw, ahtt
CC
CC----------------------------------------------------------------------
CC Common/comdhd/ : direction of lateral diffusion (momentum & tracers) 
CC -----------------------------------------------
CC Slopes ('key_trahdfiso' or 'key_s_coord' defined)
CC      uslpml()        : i-direction slope at u-, w-points at bottom
CC      wslpiml()           of mixed layer 
CC      vslpml()         : j-direction slope at v-, w-points at bottom
CC      wslpjml()          of mixed layer        
CC      uslp(), wslpi()  : i-direction slope at u-, w-points
CC      vslp(), wslpj()  : j-direction slope at v-, w-points
CC	wk1(), wk2()	 : work array used in rotated biharmonic ope-
CC	wk3(), wk4()	   rator on momentum and/or tracers
CC      omlmask()        : ocean mixed layer mask defined at t-points
C
#if defined key_trahdfiso || defined key_dynhdfiso || defined key_trahdfgeop || defined key_dynhdfgeop || defined key_debug
      REAL uslp (jpi,jpj,jpk), vslp (jpi,jpj,jpk)
      REAL wslpi(jpi,jpj,jpk), wslpj(jpi,jpj,jpk)
      REAL uslpml (jpi,jpj), vslpml (jpi,jpj)
      REAL wslpiml(jpi,jpj), wslpjml(jpi,jpj)
      REAL omlmask(jpi,jpj,jpk)
#  if defined key_trahdfbilap || defined key_dynhdfbilap
      REAL wk1(jpi,jpj,jpk), wk2(jpi,jpj,jpk)
      REAL wk3(jpi,jpj,jpk), wk4(jpi,jpj,jpk)
#   else
      REAL wk1, wk2, wk3, wk4
#  endif
C
      COMMON/comdhd/ uslp, vslp, wslpi, wslpj,
     $       wk1, wk2, wk3, wk4, omlmask,
     $       uslpml, vslpml, wslpiml, wslpjml
# else
C     diffusion along model level surfaces: no arrays
#endif
CC
CC----------------------------------------------------------------------
CC Common/comeiv/ : eddy induced velocity parameterization
CC -------------------------------------------------------
CC      aeiu(), aeiv()   : eddy induced velocity coef. at u-, v- and
CC      aeiw()             w-points (m2/s). The arrays used are 3D
CC                         2D, 1D or 0D, depending on 'key_trahdfcoef.d'
C
#if defined key_trahdfeiv
#  if defined key_trahdfcoef3d
      REAL aeiu(jpi,jpj,jpk), aeiv(jpi,jpj,jpk), aeiw(jpi,jpj,jpk)
#   elif defined key_trahdfcoef2d
      REAL aeiu(jpi,jpj), aeiv(jpi,jpj), aeiw(jpi,jpj)
#   elif defined key_trahdfcoef1d
      REAL aeiu(jpk), aeiv(jpk), aeiw(jpk)
#   else
      REAL aeiu, aeiv, aeiw
#  endif
# else
      REAL aeiu, aeiv, aeiw
#endif
C
      COMMON/comeiv/ aeiu, aeiv, aeiw
CC
CC----------------------------------------------------------------------
CC Common/comzdf/ : vertical diffusion
CC -----------------------------------
CC	avmu(), avmv()   : vertical viscosity coeff. at uw-, vw-points
CC	avt()	         : vertical diffusivity coeff. at w-point
CC	avs()	         : vertical diffusivity coeff. at w-point
CC			   for salinity ('key_ddmixing' defined)
CC	rrau()	         : heat/salt buoyancy flux ratio
CC	avmb(), avtb()   : background profile of avm and avt
C
      REAL avmu(jpi,jpj,jpk), avmv(jpi,jpj,jpk), avt(jpi,jpj,jpk)
      REAL avmb(jpk), avtb(jpk)
#if defined key_ddmixing
      REAL avs(jpi,jpj,jpk), rrau(jpi,jpj,jpk)
# else
      REAL avs, rrau
#endif
C
      COMMON/comzdf/ avmu, avmv, avt, avs, rrau, avmb, avtb
CC
#if defined key_zdfrichardson || defined key_debug
CC----------------------------------------------------------------------
CC Common/comric/ : Richardson number dependent vertical diffusion
CC ---------------------------------------------------------------
CC	tmric	         : coef. for the horizontal mean at t-point
C
      REAL tmric(jpi,jpj,jpk)
C
      COMMON/comric/ tmric
#endif
CC
#if defined key_zdftke || defined key_debug
CC----------------------------------------------------------------------
CC Common/comtke/ : turbulent eddy kinetic dependent vertical diffusion
CC --------------------------------------------------------------------
CC	en()	         : turbulent kinetic energy
CC	etmean(),eumean(): coefficient used for horizontal smoothing
CC	evmean()           at t-, u-, and v-points
C
      REAL en    (jpi,jpj,jpk), etmean(jpi,jpj,jpk),
     $     eumean(jpi,jpj,jpk), evmean(jpi,jpj,jpk)
C
      COMMON/comtke/ en, etmean, eumean, evmean
#endif
CC
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC IV. SURFACE FORCING AND DATA
CC ============================
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC Common/comtar/ : surface wind stress data read
CC ----------------------------------------------
CC      taudta()         : daily AGCM wind stress
C
#if defined key_tau || defined key_debug
CC
CC      ntau1, ntau2     : first and second record used
CC      ndaytau          : new day for ecmwf tau forcing 
CC      nyeartau         : new year for ecmwf tau forcing
C
      INTEGER ntau1, ntau2, ndaytau, nyeartau
C
      COMMON/cimtar/ ntau1, ntau2, ndaytau, nyeartau
C
#if defined key_tau_ers_ncep
CC
CC      taudta()         : monthly stress 
CC                         at U (Txu,Tyu) and V (Tyv,Tyv)
C
      REAL taudta(jpi,jpj,2,4)
C
#    elif defined key_tau_clio
CC
CC      taudta()         : monthly stress 
CC                         at U (Txu,Tyu) and V (Tyv,Tyv)
C
      REAL taudta(jpi,jpj,2,6)
#    elif defined key_tau_lmd
CC
CC      taudta()         : monthly stress 
CC                         at U (Txu,Tyu) and V (Tyv,Tyv)
C
      REAL taudta(jpi,jpj,2,6)
#    else
CC
CC      taudta()         : dummy argument
C
      REAL taudta
#  endif
C
      COMMON/comtar/ taudta
#endif
CC
CC----------------------------------------------------------------------
CC Common/comtau/ : surface wind stress at givem time_step
CC -------------------------------------------------------
CC	taux(), tauy()   : wind stress components in (i,j) referential
CC	tauxg(), tauyg() : zonal and meridian wind stress component used
CC	                   in output (geographical referential)
C
      REAL taux(jpi,jpj), tauy(jpi,jpj)
      REAL tauxg(jpi,jpj), tauyg(jpi,jpj)
C
      COMMON/comtau/ taux, tauy, tauxg, tauyg
CC
CC----------------------------------------------------------------------
CC Common/comssr/ : surface temperature data read
CC ----------------------------------------------
CC      nsst1, nsst2     : first and second record used
C
      INTEGER nsst1, nsst2
C
      COMMON/cimssr/ nsst1, nsst2
CC
#if defined key_sst || defined key_debug
CC
CC      njdater   : number of weeks in present year
CC      ndater()  : date at the beginning of the week in Reynolds sst data
CC      nrecr     : record number associated with present week in Reynolds data
CC      nnyrey    : year of the Reynolds file to use
CC      ndaysst   : new day for Reynolds sst
CC      nyearsst  : new year for Reynolds sst
CC
      INTEGER njdater, ndater(53), nrecr, nnyrey, ndaysst, nyearsst
C
      COMMON/comssr/njdater, ndater, nrecr, nnyrey, ndaysst, nyearsst
C
C      REAL sstdta(jpi,jpj,2)
C
C      COMMON/comssr/ sstdta
CC
#  else
CC      no surface temperature data read
#endif
CC
CC----------------------------------------------------------------------
CC Common/comicr/ : climatological ice restoring
CC ----------------------------------------------
CC      rclice()         : climatological ice index (0/1) (2 months)
CC      nice1, nice2     : first and second record used in ice file
C
      REAL rclice(jpi,jpj,2)
      COMMON/comicr/ rclice
C
      INTEGER nice1, nice2
      COMMON/cimflr/ nice1, nice2
CC
CC----------------------------------------------------------------------
CC Common/comsst/ : surface temperature at givem time_step
CC -------------------------------------------------------
CC      nconss           : variable for time interpolation
C
      INTEGER nconss
C
      COMMON/cimsst/ nconss
C
CC      sst()     : ssurface temperature
C
      REAL sst(jpi,jpj)
C
      COMMON/comsst/ sst
CC
CC----------------------------------------------------------------------
CC Common/comflr/ : surface fluxes stress data read
CC ------------------------------------------------
#if defined key_flx || defined key_debug
CC      numfl1           : logical unit for surface fluxes data
CC      nflx1, nflx2     : first and second record used
CC      ndayflx          : new day for ecmwf flx forcing
CC      nyearflx         : new year for ecmwf flx forcing
C
      INTEGER numfl1, nflx1, nflx2, nflx11, nflx12, ndayflx, nyearflx
      COMMON/cimflr/ numfl1,
     $               nflx1, nflx2, nflx11, nflx12, ndayflx, nyearflx
C
# if defined key_flx_clio
C
CC      flxdta()  : CLIO monthly fluxes
C
      INTEGER numfl2,numfl3,numfl4,numfl5
      COMMON/cimflr2/ numfl2,numfl3,numfl4,numfl5
      REAL watm(jpi,jpj),tatm(jpi,jpj),hatm(jpi,jpj),vatm(jpi,jpj),
     $    catm(jpi,jpj)
      REAL flxdta(jpi,jpj,2,7)
      COMMON/comflr2/watm,tatm,hatm,vatm,catm
C
#  elif defined key_flx_lmd
C
CC      flxdta()  : LMD monthly fluxes
C
      REAL flxdta(jpi,jpj,2,13)
      REAL flxdmp(jpi,jpj), tatm_ice(jpi,jpj), tatm_wat(jpi,jpj)
      COMMON/comflr2/flxdmp, tatm_ice, tatm_wat
C
#    else
C
CC      flxdta()         : daily fluxes
C
      REAL flxdta(jpi,jpj,3)
C
#  endif
C
      COMMON/comflr/ flxdta
C
#  else
CC      no surface fluxes data read
#endif
CC
CC----------------------------------------------------------------------
CC Common/comflx/ : surface fluxes
CC -------------------------------
CC      qt()             : total surface heat flux (w m-2)
CC      q()              : surface heat flux (w m-2)
CC      emp()            : evaporation minus precipitation (kg m-2 s-2)
CC      emps()           : evaporation - precipitation (free surface)
CC      freeze(),freezn(): after and now ice mask (0 or 1)
CC      fzptb(), fzpt()  : before and now freezing point
CC      qrp()            : heat flux damping (mm day-1)
CC      erp()            : evaporation damping (mm day-1)
C
      REAL qt(jpi,jpj), q(jpi,jpj), emp(jpi,jpj), emps(jpi,jpj)
      REAL freezn(jpi,jpj), freeze(jpi,jpj)
      REAL fzpt(jpi,jpj), fzptb(jpi,jpj), qrp(jpi,jpj), erp(jpi,jpj)
C
      COMMON/comflx/ qt, q, emp, emps,freezn, freeze, fzpt, fzptb,
     $              qrp, erp
CC
CC
CC----------------------------------------------------------------------
CC Common/cimrnf/ : runoff data read
CC ---------------------------------
CC      numrof           : logical unit for runoff data
CC      nrunoff          : runoff option (namelist)
CC      nrnf1, nrnf2     : first and second record used
C
      INTEGER numrof, nrunoff, nrnf1, nrnf2
C
      COMMON/cimrnf/ numrof, nrunoff, nrnf1, nrnf2
C
CC      rnfdta           : monthly runoff data array (kg/m2/s)
C
      REAL rnfdta(jpi,jpj,2)
C
      COMMON/comrdr/ rnfdta
CC
CC----------------------------------------------------------------------
CC Common/comrnf/ : runoff data at given time-step
CC -----------------------------------------------
CC  runoff()  : monthly runoff (kg/m2/s)
CC  upsrnfh() : mixed upstream-centered scheme: runoffs vicinity (hori.)
CC  upsrnfz() : mixed upstream-centered scheme: runoffs vicinity (vert.)
CC  upsadv()  : mixed upstream-centered scheme: straits vicinity (hori.)
C
      REAL runoff(jpi,jpj),
     $     upsrnfh(jpi,jpj), upsrnfz(jpk), upsadv(jpi,jpj)
C
      COMMON/comrnf/ runoff, upsrnfh, upsrnfz, upsadv 
CC
CC----------------------------------------------------------------------
CC Common/comqsr/ : penetrative solar radiation
CC --------------------------------------------
CC	qsr()	         : solar radiation (w m-2)
C
      REAL qsr(jpi,jpj)
CC
#if ! defined key_s_coord
CC	nksr	         : number of levels
CC	gdsr()	         : coef. of penetration profile
C
      INTEGER nksr
      REAL gdsr(jpk)
C
      COMMON/cimqsr/ nksr
C
      COMMON/comqsr/ gdsr, qsr
#  else
      COMMON/comqsr/ qsr
#endif
CC
CC----------------------------------------------------------------------
CC Common/comtdr/ : temperature data read
CC --------------------------------------
CC      numte1           : logical unit for temperature data
CC      ntem1, ntem2     : first and second record used
CC      nlecte           : switch for the first read
CC      numtem           : logical unit for initial temperature (for EEL)
C
      INTEGER numte1, ntem1, ntem2, nlecte
#if defined key_eel2 || defined key_eel6
     $       , numtem
#endif
C
      COMMON/cimtdr/ numte1, ntem1, ntem2, nlecte
#if defined key_eel2 || defined key_eel6
     $       , numtem
#endif
C
#if defined key_temdta || defined key_debug
CC
CC      temdta()         : temperature data array
C
      REAL temdta(jpi,jpj,jpk,2)
C
      COMMON/comtdr/ temdta
CC
CC----------------------------------------------------------------------
CC Common/comtda/ : temperature data at givem time-step
CC ----------------------------------------------------
CC      tdta()           : temperature data at given time-step
C
      REAL tdta(jpi,jpj,jpk)
C
      COMMON/comtda/ tdta
#  else
CC      no temperature data read
#endif
CC
CC----------------------------------------------------------------------
CC Common/comsdr/ : salinity data read
CC -----------------------------------
CC      numsa1           : logical unit for salinity data
CC      nsal1, nsal2     : first and second record used
CC      nlecsa           : switch for the first read
C
      INTEGER numsa1, nsal1, nsal2, nlecsa
C
      COMMON/cimsdr/ numsa1, nsal1, nsal2, nlecsa
CC
#if defined key_saldta || defined key_debug
CC      saldta()         : salinity data array
C
#if defined key_saldta_monthly
      REAL saldta(jpi,jpj,jpk,2)
#  else
      REAL saldta(jpi,jpj,jpk,4)
#endif
C
      COMMON/comsdr/ saldta
CC
CC----------------------------------------------------------------------
CC Common/comsda/ : salinity data at givem time_step
CC -------------------------------------------------
CC      sdta()           : salinity data at given time-step
C
      REAL sdta(jpi,jpj,jpk)
C
      COMMON/comsda/ sdta
#  else
CC      no salinity data read
#endif
CC
#if (defined key_temdta && defined key_saldta && defined key_tradmp) || (defined key_temdta && defined key_saldta && defined key_arctic) || (defined key_temdta && defined key_saldta && defined key_antarctic) || defined key_debug
CC----------------------------------------------------------------------
CC Common/comtdp/ : temperature and salinity damping
CC -------------------------------------------------
CC	resto()	         : array of restoring coeff. on T and S (s-1)
C
      REAL resto(jpi,jpj,jpk), strdmp(jpi,jpj,jpk)
C
      COMMON/comtdp/ resto, strdmp
#endif
CC
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC V. DIAGNOSTICS
CC ==============
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
#if defined key_diatrdtra || defined key_diatrdmld || defined key_debug
CC----------------------------------------------------------------------
CC Common/comtra/ : tracers trends
CC -------------------------------
CC      tvolt            : intergral of volume factors at t-points
CC      ttrd(),          : trends of the tracer equations :
CC            ttrd(,,,1) : horizontal advection
CC            ttrd(,,,2) : vertical advection
CC            ttrd(,,,3) : horizontal diffusion
CC            ttrd(,,,4) : vertical diffusion
CC            ttrd(,,,5) : static instability
CC            ttrd(,,,6) : damping OR vertical EIV 
CC            ttrd(,,,7) : penetrative solar radiation (T only)
CC            ttrdh(,,,1) : zonal advection
CC            ttrdh(,,,2) : meridional advection
CC            ttrdh(,,,3) : zonal EIV
CC            ttrdh(,,,4) : meridional EIV
CC
CC      strd() idem ttrd()
CC      flxtrd()         : tracer forcing trends
CC      bbltrd()         : tracer bottom boundary layer trends
C
      REAL tvolt
      REAL ttrd(jpi,jpj,jpk,7), ttrdh(jpi,jpj,jpk,jptrdh)
      REAL strd(jpi,jpj,jpk,6), strdh(jpi,jpj,jpk,jptrdh)
      REAL flxtrd(jpi,jpj,2), bbltrd(jpi,jpj,2)
C
      COMMON/comtra/ tvolt, ttrd, ttrdh, flxtrd, bbltrd
     $                    , strd, strdh

#endif
#if defined key_ice_igloo && ! defined key_diatrdtra && ! defined key_diatrdmld
CC
CC   flxtrd()            : tracer forcing trends
C
      REAL flxtrd(jpi,jpj,2)
C
      COMMON/comtra/ flxtrd
#endif
CC
#if defined key_diatrddyn || defined key_debug
CC----------------------------------------------------------------------
CC Common/comtrd/ : dynamics trends
CC --------------------------------
CC	tvols,	         : intergral of volume factors at t-points
CC	tvolu,	         : intergral of volume factors at u-, v-points
CC	tvolv,      over the whole ocean basin
CC      rpktrd           : potential to kinetic energy conversion
CC	utrd(),	         : trends of the momentum equation
CC      vtrd()
CC      utrd2(),vtrd2()  : trend with the free surface formulation
CC	tautrd()         : momentum forcing trends
C
      REAL tvols, tvolu, tvolv, rpktrd
      REAL utrd(jpi,jpj,jpk,9), vtrd(jpi,jpj,jpk,9)
      REAL utrd2(jpi,jpj,jpk,2),vtrd2(jpi,jpj,jpk,2)
      REAL tautrd(jpi,jpj,4)
C
      COMMON/comtrd/ tvols, tvolu, tvolv, rpktrd,
     $              utrd, vtrd, utrd2, vtrd2, tautrd
#endif
CC
CC----------------------------------------------------------------------
CC Common/comrun/ : parameters for the control
CC -------------------------------------------
CC      numnam           : logical unit for namelist
CC      numcot           : logical unit for file distance to coast
CC      numdmp           : logical unit for file restoring damping term 
CC      numrst           : logical unit for restart file
CC      ndastp           : time step date in year/month/day aammjj
CC      nnpcc            : number of statically instable water column
CC      nnpci            : number of iteration for npc scheme
CC      no1              : restart run number
CC      nt1              : restart time-step
CC      npcg1            : restart pcg option
CC      nsor1            : restart sor option
CC      ntke1            : restart tke option
CC      ndast1           : restart date
CC      neuler           : restart euler forward option (0=Euler)
CC      newday           : new day  (0 = no new day, 1 = new day
CC                                                   2 = first day)
CC      njulian0         : julian day for nit000
CC      njulian          : julian day (number of day from 1jan)
CC      nday0            : integer of previous fraction of day 
CC      nday1            : integer of current fraction of day
CC      nday             : number of iterations explain in day quanta          
CC      rdate            : model date in year/month/day/hour aammjj.hh
CC      gday0            : calandar previous fraction of day
CC      gday1            : calandar current fraction of day
CC      gday             : number of iterations explain in day quanta

C
      INTEGER numnam, numcot, numdmp, numrst
      INTEGER ndastp, nnpcc, nnpci
      INTEGER no1, nt1, npcg1, nsor1, ntke1, ndast1, neuler, newday
      INTEGER njulian, njulian0
      INTEGER nday, nday0, nday1
C
      COMMON/cimrun/ numnam, numcot, numdmp, numrst,
     $       ndastp,
     $       nnpcc, nnpci,
     $       no1, nt1, npcg1, nsor1, ntke1, ndast1, neuler, newday,
     $       njulian, njulian0, nday, nday0, nday1
CC
      CHARACTER (len=2) cfreq
C
      COMMON/clmrun/ cfreq
C
      REAL rdate, gday, gday0, gday1
C
      COMMON/comrun/ rdate, gday, gday0, gday1
CC
CC----------------------------------------------------------------------
CC Common/comwri/ : opa output
CC ---------------------------
CC      numout           : logical unit for output print
CC      numwri           : logical unit for output write
CC      numwda           : logical unit for date write
CC      numwso           : logical unit for 2d vairmer output write
CC      numwvo           : logical unit for 3d vairmer output write
CC      numwrs           : logical unit for output restart
CC      niosta           : i/o general status
CC      ndaout           : output date yymmdd
CC      nmoyct           : time step for average
CC      nstepo           : output number
C
      INTEGER numout, numwri, numwso, numwvo, numwrs
      INTEGER niosta, numwda, ndaout
      INTEGER nmoyct, nstepo
C
      COMMON/cimwri/ numout, numwri, numwso, numwvo, numwrs,
     $       nmoyct, niosta, nstepo, numwda, ndaout
C
#if defined key_mpp || defined key_fdir || defined key_vairmer 
#    if ! defined key_diainstant
CC output on mean values
CC
CC averages : 3d arrays
CC      um(), vm(), wm() : average value of velocity components
CC      tm(), sm()       : average value of temperature and salinity
CC      am()             : average value of vert.diffusivity coef.
C
      REAL um(jpi,jpj,jpk), vm(jpi,jpj,jpk)
      REAL wm(jpi,jpj,jpk), tm(jpi,jpj,jpk)
      REAL sm(jpi,jpj,jpk), am(jpi,jpj,jpk)
CC
#        if defined key_vairmer
CC averages : 2d arrays
CC      ftxm ()          : average value of zonal wind stress
CC      ftym ()          : average value of meridonal wind stress
CC      fqm  ()          : average value of surface heat flux condition
CC      fqsrm()          : average value of radiation
CC      fqnsm()          : average value of non solar heat flux
CC      femp ()          : average value of upward water flux
CC      fqrpm()          : average value of heat flux damping
CC      ferpm()          : average value of water flux damping
CC      fstdm()          : average value of surface temperature data
CC      fbsfm()          : average value of barotropic stream function
CC      fpgxm(), fpgym() : average value of i-, j-surf. pres. gradient
CC averages : 2d arrays, additionnal
CC      fhmldm ()        : average value of turbocline depth
CC      fhmlpm ()        : average value of mixed layer depth
CC      fhthm ()         : average value of max vert. temp. gradient
CC      fhd20m ()        : average value of 20 C isotherm depth
CC      fesm ()          : average value of salt flux
CC      frnm ()          : average value of run off
CC      fhicem ()        : average value of ice index
C
      REAL ftxm  (jpi,jpj), ftym  (jpi,jpj), fqm   (jpi,jpj),
     $     fqsrm (jpi,jpj), femp  (jpi,jpj), fqrpm (jpi,jpj),
     $     fstdm (jpi,jpj), fbsfm (jpi,jpj), fpgxm (jpi,jpj),
     $     fpgym (jpi,jpj), fhmldm(jpi,jpj), fqnsm (jpi,jpj),
     $     fhmlpm(jpi,jpj),
     $     ferpm (jpi,jpj), fhthm (jpi,jpj), fhd20m(jpi,jpj),
     $     fesm  (jpi,jpj), frnm  (jpi,jpj), fhicem(jpi,jpj)
C
      COMMON/comwri/ um, vm, wm, tm, sm, am,
     $              ftxm, ftym, fqm, fqsrm, femp, fqrpm, fstdm, fbsfm,
     $              fpgxm, fpgym, fhmldm, fqnsm, fhmlpm,
     $              ferpm, fhthm, fhd20m, fesm, frnm, fhicem
#          else
CC averages : 2d mpp arrays
CC      fsel   ()        : average value
C
      REAL fsel(jpi,jpj,jpk)
C
      COMMON/comwri/ um, vm, wm, tm, sm, am, fsel
#        endif 
#    endif
#else
c
c    netcdf files and index common
c
c for diawri and diabort
      INTEGER nid1,ndepid1,nhorid1
     $       ,ndex10(jpi*jpj*jpk),ndim10
     $       ,ndex11(jpi*jpj),ndim11
     $       ,nid2,ndepid2,nhorid2
     $       ,ndex20(jpi*jpj*jpk),ndim20
     $       ,ndex21(jpi*jpj),ndim21
     $       ,nid3,ndepid3,nhorid3
     $       ,ndex30(jpi*jpj*jpk),ndim30
     $       ,ndex31(jpi*jpj),ndim31
     $       ,nid4,ndepid4,nhorid4
     $       ,ndex40(jpi*jpj*jpk),ndim40
     $       ,ndex41(jpi*jpj),ndim41
      INTEGER nida,ndepida,nhorida
     $       ,ndexa(jpi*jpj*jpk),ndima
     $       ,ndexa1(jpi*jpj),ndima1
#if defined key_diatrdtra
     $       ,nid5,ndepid5,nhorid5
     $       ,ndex50(jpi*jpj*jpk),ndim50
     $       ,ndex51(jpi*jpj),ndim51
     $       ,nid6,ndepid6,nhorid6
     $       ,ndex60(jpi*jpj*jpk),ndim60
     $       ,ndex61(jpi*jpj),ndim61
#endif
     $       ,ndex(1)
c for diaznl
     $       ,nidz,nhoridz,ndepidzt,ndepidzw
c for diagap
     $       ,nhoridg,ndepidg
#if defined key_diatrdmld
c for diamld
     $       ,nidtrd,nhoridtrd
     $       ,ndextrd1(jpi*jpj),ndimtrd1
#endif
      COMMON/CIMCDF1/nid1,ndepid1,nhorid1
     $             ,ndex10,ndim10
     $             ,ndex11,ndim11
     $             ,nid2,ndepid2,nhorid2
     $             ,ndex20,ndim20
     $             ,ndex21,ndim21
     $             ,nid3,ndepid3,nhorid3
     $             ,ndex30,ndim30
     $             ,ndex31,ndim31
     $             ,nid4,ndepid4,nhorid4
     $             ,ndex40,ndim40
     $             ,ndex41,ndim41
      COMMON/CIMCDF2/nida,ndepida,nhorida
     $             ,ndexa,ndima
     $             ,ndexa1,ndima1
#if defined key_diatrdtra
     $             ,nid5,ndepid5,nhorid5
     $             ,ndex50,ndim50
     $             ,ndex51,ndim51
     $             ,nid6,ndepid6,nhorid6
     $             ,ndex60,ndim60
     $             ,ndex61,ndim61
#endif
     $             ,ndex
     $             ,nidz,nhoridz,ndepidzt,ndepidzw
     $             ,nhoridg,ndepidg
#if defined key_diatrdmld
     $             ,nidtrd,nhoridtrd
     $             ,ndextrd1,ndimtrd1
#endif
#endif
CC
CC----------------------------------------------------------------------
CC Common/comgap/ : gap between model and data tracers
CC ---------------------------------------------------
CC      numgap           : logical unit for differences diagnostic
CC      ngap             : time step frequency
CC      nprg             : switch for control print
C
      INTEGER numgap, ngap, nprg
C
      COMMON/cimgap/ numgap, ngap, nprg
CC
#if defined key_diagap || defined key_debug
CC      vol              : total volume
CC      volk()           : vertical volume
C
      REAL vol
      REAL volk(jpk)
C
      COMMON/comvol/ vol,
     $              volk
CC
CC      tdtag()          : averaged data temperature
CC      sdtag()          : averaged data salinity
CC      tmodg()          : averaged model temperature
CC      smodg()          : averaged model salinity
CC      tvarg()          : variance between model and data temperature
CC      svarg()          : variance between model and data salinity
C
      REAL tdtag(jpk), sdtag(jpk), tmodg(jpk), smodg(jpk)
      REAL tvarg(jpk), svarg(jpk)
C
      COMMON/comgap/ tdtag, sdtag, tmodg, smodg, tvarg, svarg
#  else
CC      no differences computation  between model and data
#endif
CC
CC----------------------------------------------------------------------
CC Common/comznl/ : zonal fluxes computation
CC -----------------------------------------
CC two methods :
CC              a) through J lines in the North hemisphere (no exact)
CC              b) through broken lines closer latitude cercles 
CC                 (key_diaznl_brokenline) It s more expensive in CPU
CC                 time and memory (uvmsk array)
CC      numznl           : logical unit for atlantic bathymetry
CC      numwzl           : logical unit for zonal mean output
CC      nfznl            : time step frequency
C
      INTEGER numznl, numwzl, nfznl
C
      COMMON/cimznl/ numznl, numwzl, nfznl
C
#if defined key_diaznl && ! defined key_antarctic && ! defined key_arctic
#  if defined key_diaznl_brokenline
CC      uvmsk()          : mask of t-latitude circles
CC      tznlmk()         : tmask for the specific bathymetry(ex:atlantic)
CC      uznlmk()         : umask 
CC      vznlmk()         : vmask 
CC      fbt()            : total volum
C
      REAL uvmsk(jpi,jpj,jpj)
      REAL tznlmk(jpi,jpj,2), uznlmk(jpi,jpj,2), vznlmk(jpi,jpj,2)
      REAL fbt(jpj,jpk,2)
#      else
CC      vmkatl()         : surface vmask of the Atlantic sector
CC      fvs()            : masked surface of j-sections at v-points for
CC			   the global ocean and the Atlantic sector
CC
      REAL vmkatl(jpi,jpj), fvs(jpjglo,jpk,2)
#  endif
CC
#  if defined key_trahdfiso
CC      fhd(), fsd()     : isopycnal diffusion fluxes for T and S
CC
      REAL fhd(jpj,jpk,2), fsd(jpj,jpk,2)
#    if defined key_trahdfeiv
CC      fhei(), fsei()   : eddy induced fluxes for T and S
CC
      REAL fhei(jpj,jpk,2), fsei(jpj,jpk,2)
#    endif
#  endif
C
#  if defined key_diaznl_brokenline
      COMMON/comznl/ uvmsk, tznlmk, uznlmk, vznlmk, fbt
#    else 
      COMMON/comznl/ vmkatl, fvs
#  endif
#  if defined key_trahdfiso
     $              , fhd, fsd
#    if defined key_trahdfeiv
     $    ,fhei , fsei
#    endif
#  endif
# else
CC      no  zonal fluxes computation
#endif
CC
#if defined key_diaspr
CC----------------------------------------------------------------------
CC Common/comspr/  : surface pressure
CC ---------------------------------
CC      gps()        : surface pressure)
CC      spgum,spgvm(): average value of the surface pressure gradients
CC      gpsuu,gpsvv(): surface pressure gradients computed from comp. PS
CC      gcps()       : extra-diagonal elements of SPG matrix
CC      gcdpsc()     : inverse diagonal preconditioning matrix
CC      gcsmat()     : diagonal preconditioning matrix
CC      spmsk()      : surface pressure Mask
CC      nmoyps       : time step for average
CC      nindic       : indicator of convergence of the solver
CC
      INTEGER nmoyps, nindic
CC
      COMMON/cimspr/nindic, nmoyps
CC
      REAL e1e2t
      REAL gps(jpi,jpj)
      REAL gpsuu(jpi,jpj), gpsvv(jpi,jpj)
      REAL spgum(jpi,jpj), spgvm(jpi,jpj)
      REAL gcps(jpi,jpj,4), gcdpsc(jpi,jpj), gcsmat(jpi,jpj)
      REAL spmsk(jpi,jpj)
C
      COMMON/comspr/e1e2t, gps, spgum, spgvm, gcps, gcdpsc, gcsmat,
     $    spmsk, gpsuu, gpsvv
#endif
CC
CC----------------------------------------------------------------------
CC Common/comdia/ : Additional diagnostics
CC ----------------------------------------
CC    nmln()             : sub-pycnocline level (rho criteria)
CC    hmld()             : mixing layer depth (turbocline)
CC    hmlp()             : mixed layer depth  (rho=rho0+zdcrit)
CC    hmlpt()            : mixed layer depth at t-points
CC    hmln()             : mixed layer depth  (bn2 criteria)
CC    hth()              : max vertical temperature gradient
CC    hd20()             : depth of 20 C isotherm
CC    hd28()             : depth of 28 C isotherm
CC    htc3()             : heat content of first 300 m
C
      INTEGER nmln(jpi,jpj)
C
      COMMON/cimdia/ nmln
C  
      REAL hmld(jpi,jpj), hmlp(jpi,jpj), hmln(jpi,jpj), hmlpt(jpi,jpj)
      REAL hth(jpi,jpj), hd20(jpi,jpj), hd28(jpi,jpj), htc3(jpi,jpj)
C
      COMMON/comdia/ hmld, hmlp, hmln, hth, hd20, hd28, htc3,hmlpt
CC
CC----------------------------------------------------------------------
CC COMMON/comeid/ : EIV diagnostic velocity
CC ----------------------------------------
#if defined key_diaeiv && defined key_trahdfeiv
CC    ugm(), vgm(), wgm(): averaged value of eddy induced velocity
C
      REAL ugm(jpi,jpj,jpk), vgm(jpi,jpj,jpk), wgm(jpi,jpj,jpk)
C
      COMMON/comeid/ ugm, vgm, wgm
#endif
CC
CC----------------------------------------------------------------------
CC COMMON/commld/ : mixed layer trends
CC -----------------------------------
CC  see diamld.F for arrays definition
CC
      INTEGER  numbol 
#if defined key_diatrdmld || defined key_debug
      INTEGER nmld(jpi,jpj), nbol(jpi,jpj), nmoymltrd
      REAL rmld(jpi,jpj)
C Temperature
      REAL tml(jpi,jpj), tmlb(jpi,jpj), tmlbb(jpi,jpj), tmlbn(jpi,jpj)
      REAL tmltrd(jpi,jpj,jpltrd), tmltrdm(jpi,jpj)
C Salinity
      REAL sml(jpi,jpj), smlb(jpi,jpj), smlbb(jpi,jpj), smlbn(jpi,jpj)
      REAL smltrd(jpi,jpj,jpltrd), smltrdm(jpi,jpj)
#if defined key_trahdfeiv
      REAL wgn(jpi,jpj,jpk)
#endif
CC
      COMMON/cimmld/ numbol, nmld, nbol, nmoymltrd
      COMMON/commld/ rmld, tml, tmlb, tmlbb, tmlbn
     $              , tmltrd, tmltrdm
     $              , sml, smlb, smlbb, smlbn
     $              , smltrd, smltrdm
#if defined key_trahdfeiv
     $              , wgn
#endif
CC
#else
CC no mixed layer tracer trends
      COMMON/cimmld/ numbol
CC
#endif
CC
#if defined key_freesurf_cstvol
CC----------------------------------------------------------------------
CC COMMON/comfwb/ : diagnostic on fresh water budget
CC -------------------------------------------------
CC      evap()     : diagnostic on evaporation (kg m-2 s-2)
CC      precip()   : diagnostic on precipitation (kg m-2 s-2)
CC      aplus      : 
CC      aminus     : 
C
      REAL empold, memp, mevap, mprecip, mrnf,
     $     metab, metan, msalb, msaln,
     $     aplus, aminus, maminus, maplus,
     $     mflxi(4), mflxo(4), mtemi(4), mtemo(4), msali(4), msalo(4)
C
      COMMON/comfwb/ empold, memp, mevap, mprecip, mrnf,
     $     metab, metan, msalb, msaln,
     $     aplus, aminus, maminus, maplus,
     $     mflxi, mflxo, mtemi, mtemo, msali, msalo
#endif
CC
CC----------------------------------------------------------------------
CC Common/comtsk/ : multitasking
CC -----------------------------
CC      mtask()          : array of multitasking monitoring
CC
      INTEGER mtask(3,jpcpu)
CC
      COMMON/cimtsk/ mtask
CC
CC----------------------------------------------------------------------
CC Common/commpp/ : massively parallel processors
CC ----------------------------------------------
CC      lwp              : boolean term for mpp output
CC      nummpp           : logical unit for mpp test print
C
      LOGICAL lwp
C
      INTEGER nummpp
C
      COMMON/cimmpp/ lwp, nummpp
CC
#if defined key_mpp || defined key_debug 
CC      t3ew()           : 3d message passing arrays east-west    
CC      t3we()           : 3d message passing arrays west-east
CC      t3ns()           : 3d message passing arrays north-south
CC      t3sn()           : 3d message passing arrays south-north 
CC      t3p1()           : 3d message passing arrays north fold
CC      t3p2()           : 3d message passing arrays north fold
CC      t2ew()           : 2d message passing arrays east-west    
CC      t2we()           : 2d message passing arrays west-east
CC      t2ns()           : 2d message passing arrays north-south
CC      t2sn()           : 2d message passing arrays south-north 
CC      t2p1()           : 2d message passing arrays north fold
CC      t2p2()           : 2d message passing arrays south fold
C
      REAL t3ns (jpi,jprecj,jpk,2), t3sn (jpi,jprecj,jpk,2)
      REAL t3ew (jpj,jpreci,jpk,2), t3we (jpj,jpreci,jpk,2)
      REAL t3p1 (jpi,jprecj,jpk,2), t3p2 (jpi,jprecj,jpk,2)
      REAL t2ns (jpi,jprecj,2)    , t2sn (jpi,jprecj,2)
      REAL t2ew (jpj,jpreci,2)    , t2we (jpj,jpreci,2)
      REAL t2p1 (jpi,jprecj,2)    , t2p2 (jpi,jprecj,2)
C
      COMMON/commpp/ t3ns, t3sn, t3ew, t3we, t3p1, t3p2, t2ns, t2sn,
     $               t2ew, t2we, t2p1, t2p2
#  else
C     no mpp
#endif
CC
CC----------------------------------------------------------------------
CC Common/comwio/ : io workspace
CC -----------------------------
CC      tabdta()         : data auxilary array
CC      tabglo()         : global auxilary array
C
      REAL tabdta(jpidta,jpjdta), tabglo(jpiglo,jpjglo)
CC
#if defined key_mpp|| defined key_debug
CC      tabio()          : i/o workspace array
C
      REAL tabio(jpi,jpj,jpnij,jpkmod)
CC
      COMMON/comw3d/ tabdta, tabglo, tabio
#  else
      COMMON/comw3d/ tabdta, tabglo
#endif
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC Atmosphere/Ice/Ocean Coupling
CC ==============================
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC Coupling Common
CC ---------------
CC
#if defined key_coupled
#    include "common.coupled.h"
#endif
CC
CC----------------------------------------------------------------------
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC SEA ICE MODEL
CC =============
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC ice Common
CC ----------
CC
CC      numicl           : unit to read ice clim
C
      INTEGER numicl
C
      COMMON/comice/ numicl
C
#if defined key_ice_igloo
CC IGLOO
#    include "common.ice.h"
#endif
CC
      INTEGER nfice
      COMMON/cimlln/ nfice
#if defined key_ice_lln
CC LLN
CC sbcocn : field exchanges with ice model
CC alb_ice : albedo of ice
CC tn_ice  : surface temperature of ice
      REAL sbcocn(jpi,jpj,11)
      REAL alb_ice(jpi,jpj), tn_ice(jpi,jpj)
CC
#if defined key_coupled || key_flx_lmd
      REAL sciobc(jpi,jpj,13)
      COMMON/comlln/ sbcocn, sciobc, alb_ice, tn_ice
#else
      COMMON/comlln/ sbcocn, alb_ice, tn_ice
#endif
#endif
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC PASSIVE TRACER MODEL
CC ====================
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC passive tracers Common
CC ----------------------
CC
#if defined key_passivetrc
#    include "common.passivetrc.h"
#endif
CC
CC>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CC
CC OPEN BOUNDARIES
CC ===============
CC
CC<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CC
CC----------------------------------------------------------------------
CC open boundary common
CC --------------------
CC
#if defined key_eastobc || defined key_westobc || defined key_southobc || defined key_northobc
#include "common.obc.h"
#endif
CC
CC----------------------------------------------------------------------
