CCC $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_ORCA/flx.coupled.clio.h,v 1.1.1.1.6.3 2002/02/04 13:45:19 maisonna Exp $
CCC
CCC        flx.coupled.h
CCC      *****************
CCC
CC
CC   Define key : 'key_coupled' and 'key_ice_lln'
CC   ==========
CC
CC   Method :
CC   -------
CC      Read fluxes from a coupled Atmospheric model 
CC
CC   Input :
CC   ------
CC
CC   Output :
CC   -------
CC
CC   References : The OASIS User Guide, Version 2.0, CERFACS/TR 95/46
CC   -----------
CC
CC   modifications :
CC   --------------
CC       original       : Olivier Marti
CC       adapted: 01/06 : (S.Valcke, E. Maisonnave) Predicate version
CC       
CC----------------------------------------------------------------------
CC parameters and commons
CC ======================
CCC TEMPORARY IOIPSL OUTPUTS START
C      USE ioipsl
CCC TEMPORARY IOIPSL OUTPUTS END
CDIR$ NOLIST
#include "parameter.h"
#include "common.h"
cDIR$ LIST
CC----------------------------------------------------------------------
CC local declarations
CC ==================
      INTEGER kt
      INTEGER ji,jj,jf
      INTEGER itm1,isize,iflag,icpliter
      INTEGER info, inuread, index, nbpos
C
      REAL zfacflx,zfacwat
      REAL ztgel,zice
      REAL znsoltot (jpiglo,jpjglo),zqsrtot (jpiglo,jpjglo)
      REAL zrunoff(jpiglo,jpjglo)
      REAL znsdqdt(jpiglo,jpjglo),zevap  (jpiglo,jpjglo)
      REAL zpliq   (jpiglo,jpjglo),zcalv  (jpiglo,jpjglo)
      REAL zpsol   (jpiglo,jpjglo)
      REAL zstemp  (jpiglo,jpjglo), zalb (jpiglo,jpjglo)
      REAL zcumulneg , zcumulpos
CCC TEMPORARY IOIPSL OUTPUTS START

C netcdf outputs
 
C      CHARACTER*80 clcplfnam
C      INTEGER nhoridcf,nidcf,ndexcf(jpi*jpj)
C      SAVE nhoridcf,nidcf,ndexcf
C      LOGICAL, SAVE :: lfirstf=.true.
C      REAL zjulian,zsec
C      INTEGER iyear,imonth,iday
CCC TEMPORARY IOIPSL OUTPUTS END
C
c     Addition for SIPC CASE
      CHARACTER*3 clmodinf       ! Header or not
      CHARACTER*3 cljobnam_r    ! Experiment name in the field brick, if any 
      INTEGER infos(3)          ! infos in the field brick, if any
CC----------------------------------------------------------------------
CC statement functions
CC ===================
CDIR$ NOLIST
#include "stafun.h"
CDIR$ LIST
CCC---------------------------------------------------------------------
CCC  OPA8, LODYC (1997)
CCC---------------------------------------------------------------------
C
C
C 0. Initialization
C------------------
C
      isize = jpiglo * jpjglo
      itm1=(kt-nit000+1)-1
CCC TEMPORARY IOIPSL OUTPUTS START
C
C initialisation for output
C
C      IF (lfirstf) THEN 
C          lfirstf=.false.
C          ndexcf(:)=0
C          clcplfnam="cpl_oce_flx"
C 
C Compute julian date from starting date of the run
C          iyear = ndastp/10000
C          imonth = ndastp/100 - iyear*100
C          iday = ndastp - imonth*100 - iyear*10000
C          iyear = ndastp/10000
C          zsec=0.
C          CALL ymds2ju(iyear,imonth,iday,zsec,zjulian)
C          CALL histbeg(clcplfnam, jpiglo,glamt,jpjglo,gphit,1,jpiglo,1
C     $        ,jpjglo,0,zjulian,rdt,nhoridcf,nidcf)
C no vertical axis
C          DO jf=1,nflxc2o
C            CALL histdef(nidcf, cpl_readflx(jf),cpl_readflx(jf),
C     $          "-",jpi, jpj, nhoridcf, 1, 1, 1, -99, 32, "inst", 
C     $          rdt,rdt)
C          END DO 
C          CALL histend(nidcf)
C      ENDIF 
CCC TEMPORARY IOIPSL OUTPUTS END
C
C caution, I presume that you have good UNIT system from coupler to OPA
C that is :
C watt/m2 for znsolc and zqsrc
C kg/m2/s for evaporation, precipitation and runoff
C
      zfacflx=1.0e0
C water should be in kg/m2/day
      zfacwat=86400.0e0
C
C
C 1. Test if we couple at the current timestep
C --------------------------------------------
C
      IF(mod(kt,nexco).eq.1)THEN
C
C*    Test what kind of message passing we are using
C      
          WRITE (numout,*) ' '
          WRITE (numout,*) 'FLX: Read fields from CPL, itm1=',itm1
          WRITE (numout,*) ' '
          CALL flush (numout)
C
          IF (cchan.eq.'SIPC') THEN
c SIPC mode
C
c             Define IF a header must be encapsulated within 
c             the field brick :
              clmodinf = 'NOT'  ! as $MODINFO in namcouple  
c 
c             reading of input field non solar flux SONSHLDO
c
              index = 1
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, znsoltot)
c 
c              reading of input field solar heat flux SOSHFLDO
c
              index = 2
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zqsrtot)
c
c             reading of input field evaporation flux SOLATHSU
c
              index = 3
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zevap)
c
c             reading of input field liquid precipitation SOTOLPSU
c
              index = 4
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zpliq)
c
c
c             reading of input field solid precipitation SOTOSPSU
c
              index = 5
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zpsol)
c
c
c             reading of input field runoff SORUNOFF
c
              index = 6
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zrunoff)
c
c
c             reading of input field calving SOCALVIN
c
              index = 7
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zcalv)
c
c
c             reading of input field surface temp 
c
CEM  On recupere la valeur moyenne de la sst vue par l'atmosphere
CEM  le jour precedent
              zstemp=sstmoy(:,:,1)
c
c
c             reading of input field flux derivative SODFLXDT
c
              index = 8
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, znsdqdt)
c
c
c             reading of input field mean albedo SOALBICE
c
              index = 9
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, zalb)
c
          ELSE IF (cchan.eq.'CLIM') THEN
c CLIM mode
C
              WRITE (numout,*) 'Reading flux from coupler '
c exchanges from atmosphere=CPL to ocean
c
CEM  On recupere la valeur moyenne de la sst vue par l'atmosphere
CEM  le jour precedent
              zstemp=sstmoy(:,:,1)
c
              DO jf=1,nflxc2o
                IF (jf.eq.1) CALL CLIM_Import (cpl_readflx(jf),itm1
     $              ,znsoltot,info)
                IF (jf.eq.2) CALL CLIM_Import (cpl_readflx(jf),itm1,
     $              zqsrtot,info)
                IF (jf.eq.3) CALL CLIM_Import (cpl_readflx(jf),itm1
     $              ,zevap,info)
                IF (jf.eq.4) CALL CLIM_Import (cpl_readflx(jf),itm1
     $              ,zpliq,info)
                IF (jf.eq.5) CALL CLIM_Import (cpl_readflx(jf),itm1
     $              ,zpsol,info)
                IF (jf.eq.6) CALL CLIM_Import (cpl_readflx(jf),itm1,
     $              zrunoff,info)
                IF (jf.eq.7) CALL CLIM_Import (cpl_readflx(jf),itm1,
     $              zcalv,info)
                IF (jf.eq.8) CALL CLIM_Import (cpl_readflx(jf),itm1,
     $              znsdqdt,info)
                IF (jf.eq.9) CALL CLIM_Import (cpl_readflx(jf),itm1,
     $              zalb,info)
                IF ( info .NE. CLIM_Ok) THEN
                    WRITE(numout,*)'Pb in reading ', cpl_readflx(jf), jf
                    WRITE(numout,*)'Couplage itm1 is = ',itm1
                    WRITE(numout,*)'CLIM error code is = ', info
                    WRITE(numout,*)'STOP in Flx'
                    CALL abort('flx.coupled.h')
                ENDIF
              END DO 
          ENDIF
CEM
C   Fichier de masque a revoir dans Oasis
C   On recopie temporairement la premiere colonne de donnees dans l 
C   avant derniere
CEM
          DO jj=1,nlcj          
            znsoltot(jpi-1,jj)=znsoltot(1,jj)
            zqsrtot(jpi-1,jj)=zqsrtot(1,jj)
            zevap(jpi-1,jj)=zevap(1,jj)
            zpliq(jpi-1,jj)=zpliq(1,jj)
            zpsol(jpi-1,jj)=zpsol(1,jj)
            zrunoff(jpi-1,jj)=zrunoff(1,jj)
            zcalv(jpi-1,jj)=zcalv(1,jj)
            znsdqdt(jpi-1,jj)=znsdqdt(1,jj)
            zalb(jpi-1,jj)=zalb(1,jj)
          END DO
CCC TEMPORARY IOIPSL OUTPUTS START
c
c netcdf outputs
c
C              DO jf=1,nflxc2o
C                IF (jf.eq.1) CALL histwrite(nidcf,cpl_readflx(1), kt,
C     $              znsoltot,jpi*jpj,ndexcf)
C                IF (jf.eq.2) CALL histwrite(nidcf,cpl_readflx(2), kt,
C     $              zqsrtot,jpi*jpj,ndexcf)
C                IF (jf.eq.3) CALL histwrite(nidcf,cpl_readflx(3), kt,
C     $              zevap,jpi*jpj,ndexcf)
C                IF (jf.eq.4) CALL histwrite(nidcf,cpl_readflx(4), kt,
C     $              zpliq,jpi*jpj,ndexcf)
C                IF (jf.eq.5) CALL histwrite(nidcf,cpl_readflx(5), kt,
C     $              zpsol,jpi*jpj,ndexcf)
C                IF (jf.eq.6) CALL histwrite(nidcf,cpl_readflx(6), kt,
C     $              zrunoff,jpi*jpj,ndexcf)
C                IF (jf.eq.7) CALL histwrite(nidcf,cpl_readflx(7), kt,
C     $              zcalv,jpi*jpj,ndexcf)
C                IF (jf.eq.8) CALL histwrite(nidcf,cpl_readflx(8), kt,
C     $              znsdqdt,jpi*jpj,ndexcf)
C                IF (jf.eq.9) CALL histwrite(nidcf,cpl_readflx(9), kt,
C     $              zalb,jpi*jpj,ndexcf)
C              END DO 
C          CALL histsync(nidcf)
C          IF (nitend-kt.LT.nexco) CALL histclo(nidcf)
CCC TEMPORARY IOIPSL OUTPUTS END
C
C copy in the subdomain
C
C en W/m2
C en kg/(day*m2)
C     At the coupling timestep, calculate sciobc that DO not depend
C     on instantaneous field values              
        zcumulneg=0.
        zcumulpos=0.
        nbpos=0
          DO jj=1,nlcj
            DO ji=1,nlci
c
            IF ( zrunoff(mindi(ji),mindj(jj)) .LT. 0. ) THEN
              zcumulneg=zcumulneg+
     $             zrunoff(mindi(ji),mindj(jj))
     $             * e1t(ji,jj)*e2t(ji,jj)*tmask(ji,jj,1)
            ELSEIF ( zrunoff(mindi(ji),mindj(jj))
     $           .GT. 0. ) THEN
              nbpos=nbpos+1
            ENDIF
            zcumulpos=zcumulpos+zrunoff(mindi(ji),mindj(jj))
     $             * e1t(ji,jj)*e2t(ji,jj)*tmask(ji,jj,1)
            END DO
          END DO
        WRITE(numout,*) 'zcumulneg ', zcumulneg
        WRITE(numout,*) 'nbpos ', nbpos
        WRITE(numout,*) 'zcumulpos ', zcumulpos
c
CEM Le champ de runoff Arpege ne doit pas comporter de valeurs negatives
CEM  Il est necessaire de sommer les valeurs dans le modele
CEM  puis de les soustraire des valeurs positives
CEM  afin de ne pas perdre une partie de la masse d'eau totale
CEM
        zcumulpos=0.
          DO jj=1,nlcj
            DO ji=1,nlci
C
c  1: le flux solaire sur l'ocean libre
              sciobc (ji,jj,1) =  zqsrtot  (mindi(ji),mindj(jj))
     $            *        (1-0.065)
     $            /        (1-zalb(mindi(ji),mindj(jj))) 
     $            * tmask(ji,jj,1) * zfacflx
c  5: le bilan hydrique (precip liquide + solide - evap)
              sciobc (ji,jj,5) = ( zpliq   (mindi(ji),mindj(jj))
     $        +                zpsol   (mindi(ji),mindj(jj))
     $        -                zevap   (mindi(ji),mindj(jj)))
     $        * tmask(ji,jj,1)
c  6: les precipitations neigeuses                           
              sciobc (ji,jj,6) =  zpsol    (mindi(ji),mindj(jj))
     $            * tmask(ji,jj,1)
c  7: le runoff (Attention, sciobc (ji,jj,7) n'est pas utilise dans le
c modele de glace mais sert a initialiser runoff dans icelln.coupled.h)
              sciobc (ji,jj,7) =  zrunoff(mindi(ji),mindj(jj))
     $            * tmask(ji,jj,1)
CEM Le champ de runoff Arpege ne doit pas comporter de valeurs negatives
CEM  Il est necessaire de sommer les valeurs dans le modele
CEM  puis de les soustraire des valeurs positives
CEM  afin de ne pas perdre une partie de la masse d'eau totale
CEM
              IF ( sciobc (ji,jj,7) .GT. 0. ) THEN         
                sciobc (ji,jj,7) = ( sciobc (ji,jj,7) +
     $            zcumulneg/nbpos / (e1t(ji,jj)*e2t(ji,jj)) )
              ELSE
                sciobc (ji,jj,7) = 0.0
              ENDIF
              zcumulpos=zcumulpos+sciobc (ji,jj,7) 
     $             * e1t(ji,jj)*e2t(ji,jj)*tmask(ji,jj,1)
c  8: la derivee des flux non solaire sur la glace 
              sciobc (ji,jj,8) =   znsdqdt (mindi(ji),mindj(jj))
     $            * tmask(ji,jj,1) * zfacflx
c  13: calving
          sciobc (ji,jj,13) =
     $        zcalv (mindi(ji),mindj(jj)) * tmask(ji,jj,1)
c     $                         0.0
c
            END DO 
          END DO 
C
        WRITE(numout,*) 'zcumulpos final', zcumulpos
C
          CALL lbc2 (sciobc(:,:, 1), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 5), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 6), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 7), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 8), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 13), 1, 1, 1, 1, 1, 1 )

C
      
c$$$          WRITE( numout,*) 'Extremas flux ', kt
c$$$          DO jf = 1, 8
c$$$            WRITE(numout,*) jf, 
c$$$     $          MINVAL(sciobc(:,:,jf),mask=(tmask(:,:,1)>0.5)),
c$$$     $          MAXVAL(sciobc(:,:,jf),mask=(tmask(:,:,1)>0.5))
c$$$          END DO 
      ENDIF
C
C     At each timestep, calculate sciobc that depend
C     on instantaneous field values (alb_ice, tn, tn_ice, freeze)
      DO jj=1,nlcj
        DO ji=1,nlci
c  2: le flux solaire sur la glace    
          sciobc (ji,jj,2) =  zqsrtot  (mindi(ji),mindj(jj))
     $            *        (1-alb_ice(mindi(ji),mindj(jj)))
     $            /        (1-zalb(mindi(ji),mindj(jj)))
     $            * tmask(ji,jj,1) * zfacflx
C
c  3: le flux non solaire  (descendant+montant) sur l'ocean
          sciobc (ji,jj,3) =  znsoltot (mindi(ji),mindj(jj))
     $            +        znsdqdt(mindi(ji),mindj(jj))
     $            *      (tn(ji,jj,1)+rt0-zstemp(mindi(ji),mindj(jj)))
     $            * tmask(ji,jj,1) * zfacflx
c  4: le flux non solaire  (descendant+montant) sur la glace
          sciobc (ji,jj,4) =  znsoltot (mindi(ji),mindj(jj))
     $            +        znsdqdt(mindi(ji),mindj(jj))
     $            *      (tn_ice(ji,jj)-zstemp(mindi(ji),mindj(jj)))
     $            *      tmask(ji,jj,1) * zfacflx
c
          CALL lbc2 (sciobc(:,:, 2), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 3), 1, 1, 1, 1, 1, 1 )
          CALL lbc2 (sciobc(:,:, 4), 1, 1, 1, 1, 1, 1 )
        END DO
      END DO
 
