CCC $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_ORCA/tau.coupled.clio.h,v 1.1.1.1.6.3 2002/02/04 13:45:32 maisonna Exp $
CCC
CCC        tau.coupled.h
CCC      *****************
CCC
CC
CC   define key : 'key_coupled'
CC   ==========
CC
CC   Method :
CC   -------
CC      Read wind stress from a coupled Atmospheric model
CC      - horizontal interpolation is done
CC
CC   Input :
CC   ------
CC
CC   Output :
CC   -------
CC
CC   References : The OASIS User Guide, Version 2.0, CERFACS/TR 95/46
CC   -----------
CC
CC   Modifications :
CC   --------------
CC      original       : Laurent Terray
CC      modified       : Laurent TERRAY (96-07) OASIS 2 Version
CC      modified       : Eric Guilyardi (96-11) horizontal interpolation
CC      modified       : 98-04 (M.A Foujols, S. Valcke, M. Imbard) OASIS2.2
CC      modified       : 01-06 (E. Maisonnave) Predicate configuration
CC----------------------------------------------------------------------
CC parameters and commons
CC ======================
CCC TEMPORARY IOIPSL OUTPUTS START
C      USE ioipsl
CCC TEMPORARY IOIPSL OUTPUTS END
CDIR$ NOLIST
#include "parameter.h"
#include "common.h"
CDIR$ LIST
CC----------------------------------------------------------------------
CC local declarations
CC ==================
      INTEGER kt
      INTEGER ji,jj,jf
      INTEGER itm1,isize,iflag,icpliter,info,inuread,index
      REAL ztaux (jpiglo,jpjglo),ztauy (jpiglo,jpjglo)
      REAL ztauxv(jpiglo,jpjglo),ztauyu(jpiglo,jpjglo)
      REAL ztauxg(jpi,jpj),ztauyg(jpi,jpj)
CCC TEMPORARY IOIPSL OUTPUTS START
C
C netcdf outputs
C 
C      CHARACTER*80 clcpltnam
C      INTEGER nhoridct,nidct,ndexct(jpi*jpj)
C      SAVE nhoridct,nidct,ndexct
C      LOGICAL, SAVE :: lfirstt=.true.
C      INTEGER iyear,imonth,iday
C      REAL zjulian,zsec
CCC TEMPORARY IOIPSL OUTPUTS END
c
c     Addition for SIPC CASE
      CHARACTER*3 clmodinf       ! Header or not
      CHARACTER*3 cljobnam_r    ! Experiment name in the field brick, if any 
      INTEGER infos(3)          ! infos in the field brick, if any
CC----------------------------------------------------------------------
CC statement functions
CC ===================
CDIR$ NOLIST
#include "stafun.h"
CDIR$ LIST
CCC---------------------------------------------------------------------
CCC  OPA8, LODYC (1997)
CCC---------------------------------------------------------------------
C
C 0. Initialization
C------------------
C
      isize = jpiglo * jpjglo
      itm1=(kt-nit000+1)-1
C
CCC TEMPORARY IOIPSL OUTPUTS START
C
C initialisation for output
C
C      IF (lfirstt) THEN 
C          lfirstt=.false.
C          ndexct(:)=0
C          clcpltnam="cpl_oce_tau"
CC
C Compute julian date from starting date of the run
C          iyear = ndastp/10000
C          imonth = ndastp/100 - iyear*100
C          iday = ndastp - imonth*100 - iyear*10000
C          iyear = ndastp/10000
C          zsec=0.
C          CALL ymds2ju(iyear,imonth,iday,zsec,zjulian)
C          CALL histbeg(clcpltnam, jpiglo,glamt,jpjglo,gphit,1,jpiglo,1
C     $        ,jpjglo,0,zjulian,rdt,nhoridct,nidct)
CC
C          CALL histdef(nidct, 'taux','taux', "-",jpi, jpj, nhoridct,
C     $        1, 1, 1, -99, 32, "inst",rdt,rdt)
C          CALL histdef(nidct, 'tauy','tauy', "-",jpi, jpj, nhoridct,
C     $        1, 1, 1, -99, 32, "inst",rdt,rdt)
C          DO jf=1,ntauc2o
C            CALL histdef(nidct, cpl_readtau(jf),cpl_readtau(jf),
C     $          "-",jpi, jpj, nhoridct, 1, 1, 1, -99, 32, "inst", 
C     $          rdt,rdt)
C          END DO 
C          CALL histend(nidct)
C      ENDIF 
CCC TEMPORARY IOIPSL OUTPUTS END
C
C 1. Reading wind stress from coupler
C -----------------------------------
C
      IF(mod(kt,nexco).eq.1)THEN
C
C* Test what kind of message passing we are using
C
        IF (cchan.eq.'SIPC') THEN 
c
c         Define IF a header must be encapsulated within the field brick :
              clmodinf = 'NOT'   ! as $MODINFO in namcouple  
c 
c         reading of input field zonal wind stress SOZOTAUX
c
              index = 1+nflxc2o
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, ztaux)
c
c         reading of input field meridional wind stress SOMETAUY
c
              index = 2+nflxc2o
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, ztauy)
c
c         reading of input field zonal wind stress SOZOTAUV (at v point)
c
              index = 3+nflxc2o
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, ztauxv)
c
c         reading of input field meridional wind stress SOMETAUU (at u point)
c
              index = 4+nflxc2o
              CALL SIPC_Read_Model(index, isize, clmodinf,  
     $            cljobnam_r, infos, ztauyu)
c 
c
          ELSE IF (cchan.eq.'CLIM') THEN 
c 
c
c exchanges from atmosphere=CPL to ocean
c
              DO jf=1,ntauc2o
                IF (jf.eq.1) CALL CLIM_Import (cpl_readtau(jf), itm1,
     $              ztaux,info)
                IF (jf.eq.2) CALL CLIM_Import (cpl_readtau(jf), itm1,
     $              ztauy,info)
                IF (jf.eq.3) CALL CLIM_Import (cpl_readtau(jf), itm1,
     $              ztauxv,info)
                IF (jf.eq.4) CALL CLIM_Import (cpl_readtau(jf), itm1,
     $              ztauyu,info)
                IF ( info .NE. CLIM_Ok) THEN
                    WRITE(numout,*)'Pb in reading ', cpl_readtau(jf), jf
                    WRITE(numout,*)'Couplage itm1 is = ',itm1
                    WRITE(numout,*)'CLIM error code is = ', info
                    WRITE(numout,*)'STOP in Fromcpl'
                    STOP 'tau.coupled.h'
                ENDIF
              END DO 
          ENDIF
C
CEM
C   Fichier de masque a revoir dans Oasis
C   On recopie temporairement la premiere colonne de donnees dans l
C   avant derniere
CEM
          DO jj=1,nlcj
            ztaux(jpi-1,jj)=ztaux(1,jj)
            ztauy(jpi-1,jj)=ztauy(1,jj)
            ztauxv(jpi-1,jj)=ztauxv(1,jj)
            ztauyu(jpi-1,jj)=ztauyu(1,jj)
          END DO
C
CCC TEMPORARY IOIPSL OUTPUTS START
C          DO jf=1,ntauc2o
C            IF (jf.eq.1) CALL histwrite(nidct,cpl_readtau(jf), kt
C     $          ,ztaux,jpi*jpj,ndexct)
C            IF (jf.eq.2) CALL histwrite(nidct,cpl_readtau(jf), kt
C     $          ,ztauyu,jpi*jpj,ndexct)
C            IF (jf.eq.3) call histwrite(nidct,cpl_readtau(jf), kt
C     $          ,ztauxv,jpi*jpj,ndexct)
C            IF (jf.eq.4) call histwrite(nidct,cpl_readtau(jf), kt
C     $          ,ztauy,jpi*jpj,ndexct)
C          END DO 
C
C          CALL histsync(nidct)
C
CCC TEMPORARY IOIPSL OUTPUTS END
C
C 2. CHANGING DATA GRID COORDINATES --> GLOBAL GRID COORDINATES
C -------------------------------------------------------------
C
          DO jj=1,jpj
            DO ji=1,jpi
              tauxg (ji,jj)= ztaux (mindi(ji),mindj(jj))
              tauyg (ji,jj)= ztauy (mindi(ji),mindj(jj))
              ztauxg(ji,jj)= ztauxv(mindi(ji),mindj(jj))
              ztauyg(ji,jj)= ztauyu(mindi(ji),mindj(jj))
            END DO
          END DO
C
          CALL repcmo(tauxg,ztauyg,ztauxg,tauyg,taux,tauy,kt)
C
CCC TEMPORARY IOIPSL OUTPUTS START
C
C sortie des composantes de vents : tauxn tauye
C
C          CALL histwrite(nidct,'taux', kt ,taux,jpi*jpj ,ndexct)
C          CALL histwrite(nidct,'tauy', kt ,tauy,jpi*jpj ,ndexct)
C          CALL histsync(nidct)
C
C       IF (nitend-kt.LT.nexco) CALL histclo(nidct)
C
CCC TEMPORARY IOIPSL OUTPUTS END
C
C Pour l'instant pas de diffrentiation de tension de vent mer libre /
c glace
c  9: la tension de vent sur l'ocean suivant i              
          sciobc (:,:, 9) = taux
c 10: la tension de vent sur la glace suivant i              
          sciobc (:,:,10) = taux
c 11: la tension de vent sur l'ocean suivant j               
          sciobc (:,:,11) = tauy
c 12: la tension de vent sur la glace suivant j               
          sciobc (:,:,12) = tauy
C
      ENDIF
C

